=== modified file 'NEWS'
--- NEWS	2012-07-09 15:23:26 +0000
+++ NEWS	2011-12-20 16:47:38 +0000
@@ -5,20 +5,6 @@
   * Fix compatibility with newer versions of gir-gtk which don't allow
     None in STRING columns of ListStores. (Jelmer Vernooij)
 
-  * Properly handle popup menus when there is no selected revision in
-    "bzr viz". (Jelmer Vernooij, #281717)
-
-  * Ignore bzr-handle-patch.desktop in sofware center.
-    (Jelmer Vernooij, #854245)
-
-  * Fix searching in tree views. (Jelmer Vernooij, #928301)
-
- CHANGES
-
-  * bzr-notify has been removed, as it was causing regressions
-    on several machines and not particularly useful.
-    (Jelmer Vernooij, #714767, #949798, #998994, #342135, #342136, #394536)
-
 0.103.0	2011-12-11
 
  FEATURES

=== modified file '__init__.py'
--- __init__.py	2012-03-16 17:28:20 +0000
+++ __init__.py	2011-12-19 17:47:22 +0000
@@ -53,6 +53,10 @@
 
 import bzrlib
 import bzrlib.api
+from bzrlib import (
+    branch,
+    config,
+    )
 from bzrlib.commands import plugin_cmds
 
 from bzrlib.plugins.gtk.info import (
@@ -130,30 +134,14 @@
     from bzrlib.plugins.gtk import commitmsgs
     commitmsgs.save_commit_messages(*args)
 
-try:
-    from bzrlib.hooks import install_lazy_named_hook
-except ImportError:
-    from bzrlib.branch import Branch
-    Branch.hooks.install_named_hook('post_uncommit',
-                                    save_commit_messages,
-                                    "Saving commit messages for gcommit")
-else:
-    install_lazy_named_hook("bzrlib.branch", "Branch.hooks",
-        'post_uncommit', save_commit_messages, "Saving commit messages for gcommit")
-
-try:
-    from bzrlib.registry import register_lazy
-except ImportError:
-    from bzrlib import config
-    option_registry = getattr(config, "option_registry", None)
-    if option_registry is not None:
-        config.option_registry.register_lazy('nautilus_integration',
-                'bzrlib.plugins.gtk.config', 'opt_nautilus_integration')
-else:
-    register_lazy("bzrlib.config", "option_registry",
-        'nautilus_integration', 'bzrlib.plugins.gtk.config',
-        'opt_nautilus_integration')
-
+branch.Branch.hooks.install_named_hook('post_uncommit',
+                                       save_commit_messages,
+                                       "Saving commit messages for gcommit")
+
+option_registry = getattr(config, "option_registry", None)
+if option_registry is not None:
+    config.option_registry.register_lazy('nautilus_integration',
+            'bzrlib.plugins.gtk.config', 'opt_nautilus_integration')
 
 def load_tests(basic_tests, module, loader):
     testmod_names = [

=== modified file 'annotate/config.py'
--- annotate/config.py	2012-02-09 02:55:06 +0000
+++ annotate/config.py	2011-09-05 03:44:26 +0000
@@ -62,8 +62,7 @@
         self.pane.set_position(self['window'].as_int('pane_position'))
         self.window.set_default_size(self['window'].as_int('width'),
                                      self['window'].as_int('height'))
-        self.window.move(
-            self['window'].as_int('x'), self['window'].as_int('y'))
+        self.window.move(self['window'].as_int('x'), self['window'].as_int('y'))
 
         if self['window'].as_bool('maximized'):
             self.window.maximize()
@@ -72,6 +71,7 @@
         self.window.connect("destroy", self._write)
         self.window.connect("configure-event", self._save_window_props)
         self.window.connect("window-state-event", self._save_window_props)
+        self.pane.connect("notify", self._save_pane_props)
 
     def _save_window_props(self, w, e, *args):
         if e.window.get_state() & Gdk.WindowState.MAXIMIZED:
@@ -83,11 +83,14 @@
         self["window"]["maximized"] = maximized
         return False
 
-    def _save_pane_props(self):
-        self["window"]["pane_position"] = self.pane.get_position()
+    def _save_pane_props(self, w, gparam):
+        if gparam and gparam.name == "position":
+            self["window"]["pane_position"] = w.get_position()
+
+        return False
 
     def _write(self, *args):
-        self._save_pane_props()
         config.ensure_config_dir_exists()
         self.write()
         return False
+

=== modified file 'annotate/gannotate.py'
--- annotate/gannotate.py	2012-03-11 18:24:06 +0000
+++ annotate/gannotate.py	2011-11-17 21:27:30 +0000
@@ -27,7 +27,6 @@
 from bzrlib.revision import NULL_REVISION, CURRENT_REVISION
 
 from bzrlib.plugins.gtk.annotate.colormap import AnnotateColorSaturation
-from bzrlib.plugins.gtk.i18n import _i18n
 from bzrlib.plugins.gtk.revisionview import RevisionView
 from bzrlib.plugins.gtk.window import Window
 
@@ -221,7 +220,7 @@
         hbox.show()
         vbox.pack_start(hbox, False, True, 0)
 
-        self.pane = pane = Gtk.Paned.new(Gtk.Orientation.VERTICAL)
+        self.pane = pane = Gtk.VPaned()
         pane.add1(swbox)
         pane.add2(self.revisionview)
         pane.show()
@@ -484,7 +483,7 @@
         self.pack_start(entry, False, False, 0)
 
         # Next/previous buttons
-        button = Gtk.Button(_i18n('_Next'), use_underline=True)
+        button = Gtk.Button('_Next')
         image = Gtk.Image()
         image.set_from_stock('gtk-go-forward', Gtk.IconSize.BUTTON)
         button.set_image(image)
@@ -492,7 +491,7 @@
                        'forward')
         self.pack_start(button, False, False, 0)
 
-        button = Gtk.Button(_i18n('_Previous'), use_underline=True)
+        button = Gtk.Button('_Previous')
         image = Gtk.Image()
         image.set_from_stock('gtk-go-back', Gtk.IconSize.BUTTON)
         button.set_image(image)

=== modified file 'branchview/treeview.py'
--- branchview/treeview.py	2012-03-23 15:02:38 +0000
+++ branchview/treeview.py	2011-10-30 08:33:37 +0000
@@ -354,7 +354,7 @@
         # from the key (that is the key is found in a REVNO at the offset 0)
         # or if a MESSAGE *contains* the key anywhere (that is, the key is
         # found case insensitively in a MESSAGE at any offset)
-        def search_equal_func(model, column, key, iter, ignored):
+        def search_equal_func(model, column, key, iter):
             return (model.get_value(iter, treemodel.REVNO).find(key) != 0
                 and model.get_value(iter, treemodel.MESSAGE).lower().find(key.lower()) == -1)
 
@@ -454,11 +454,9 @@
     def _on_revision_selected(self, widget, event):
         from bzrlib.plugins.gtk.revisionmenu import RevisionMenu
         if event.button == 3:
-            revs = []
-            rev = self.get_revision()
-            if rev is not None:
-                revs.append(rev.revision_id)
-            menu = RevisionMenu(self.branch.repository, revs, self.branch)
+            menu = RevisionMenu(self.branch.repository, 
+                [self.get_revision().revision_id],
+                self.branch)
             menu.connect('tag-added', lambda w, t, r: self.add_tag(t, r))
             menu.popup(None, None, None, None, event.button, event.get_time())
 

=== modified file 'bzr-handle-patch'
--- bzr-handle-patch	2012-03-23 12:56:39 +0000
+++ bzr-handle-patch	2011-07-31 16:50:29 +0000
@@ -2,42 +2,39 @@
 
 from bzrlib import errors, merge_directive
 from bzrlib.plugin import load_plugins
+from bzrlib.plugins.gtk.commands import open_display
+
 load_plugins()
-from bzrlib.plugins.gtk.commands import open_display
 
 import sys
 
 if len(sys.argv) < 2:
-    print "Usage: handle-patch <path>"
-    sys.exit(1)
+	print "Usage: handle-patch <path>"
+	sys.exit(1)
 
 
 path = sys.argv[1]
 
 try:
-    from bzrlib.plugins.gtk.diff import (DiffController,
-                                         MergeDirectiveController)
-    if path == '-':
-        lines = sys.stdin.readlines()
-    else:
-        lines = open(path, 'rb').readlines()
-    lines = [l.replace('\r\n', '\n') for l in lines]
-    try:
-        directive = merge_directive.MergeDirective.from_lines(lines)
-    except errors.NotAMergeDirective:
-        controller = DiffController(path, lines, allow_dirty=True)
-    else:
-        controller = MergeDirectiveController(path, directive)
-    window = controller.window
-    window.show()
-    Gtk = open_display()
-    window.connect("destroy", Gtk.main_quit)
+	from bzrlib.plugins.gtk.diff import (DiffController,
+										 MergeDirectiveController)
+	if path == '-':
+		lines = sys.stdin.readlines()
+	else:
+		lines = open(path, 'rb').readlines()
+	lines = [l.replace('\r\n', '\n') for l in lines]
+	try:
+		directive = merge_directive.MergeDirective.from_lines(lines)
+	except errors.NotAMergeDirective:
+		controller = DiffController(path, lines, allow_dirty=True)
+	else:
+		controller = MergeDirectiveController(path, directive)
+	window = controller.window
+	window.show()
+	Gtk = open_display()
+	window.connect("destroy", gtk.main_quit)
 except Exception, e:
-    from bzrlib.plugins.gtk.dialog import error_dialog
-    error_dialog('Error', str(e))
-    raise
-
-if len(sys.argv) == 3 and sys.argv[2] == 'test':
-    sys.exit(0)
-
-Gtk.main()
+	from bzrlib.plugins.gtk.dialog import error_dialog
+	error_dialog('Error', str(e))
+	raise
+gtk.main()

=== modified file 'bzr-handle-patch.desktop'
--- bzr-handle-patch.desktop	2012-03-23 13:45:02 +0000
+++ bzr-handle-patch.desktop	2011-03-06 08:24:07 +0000
@@ -8,4 +8,3 @@
 Type=Application
 Categories=Application;Development;RevisionControl;
 MimeType=text/x-diff;text/x-patch;application/x-bazaar-merge-directive;
-X-AppInstall-Ignore=true

=== added file 'bzr-notify'
--- bzr-notify	1970-01-01 00:00:00 +0000
+++ bzr-notify	2011-07-31 16:50:29 +0000
@@ -0,0 +1,92 @@
+#!/usr/bin/env python
+
+"""Run the bzr tray icon.
+
+This is a background program which will pop up a notification on the users
+screen when a commit occurs.
+"""
+
+from bzrlib.plugin import load_plugins
+load_plugins()
+
+from bzrlib.plugins.gtk.commands import open_display
+
+from bzrlib.plugins.gtk.notify import NotifyPopupMenu
+Gtk = open_display()
+
+import cgi
+import dbus
+import dbus.service
+import gobject
+import pynotify
+from bzrlib.bzrdir import BzrDir
+from bzrlib.osutils import format_date
+from bzrlib.transport import get_transport
+
+menu = NotifyPopupMenu()
+try:
+    import appindicator
+except ImportError:
+    icon = gtk.status_icon_new_from_icon_name("bzr-panel")
+    icon.connect('popup-menu', menu.display)
+    icon.set_visible(False)
+    hide_icon = lambda: icon.set_visible(False)
+    show_icon = lambda: icon.set_visible(True)
+else:
+    indicator = appindicator.Indicator ("bzr-gtk-notify",
+        "bzr-panel", appindicator.CATEGORY_OTHER)
+    indicator.set_status (appindicator.STATUS_PASSIVE)
+    indicator.set_attention_icon("bzr-panel")
+    indicator.set_menu(menu)
+    hide_icon = lambda: indicator.set_status (appindicator.STATUS_PASSIVE)
+    show_icon = lambda: indicator.set_status (appindicator.STATUS_ATTENTION)
+
+if getattr(dbus, 'version', (0,0,0)) >= (0,41,0):
+    import dbus.glib
+BROADCAST_INTERFACE = "org.bazaarvcs.plugins.dbus.Broadcast"
+bus = dbus.SessionBus()
+
+def catch_branch(revision_id, urls):
+    # TODO: show all the urls, or perhaps choose the 'best'.
+    url = urls[0]
+    try:
+        if isinstance(revision_id, unicode):
+            revision_id = revision_id.encode('utf8')
+        transport = get_transport(url)
+        a_dir = BzrDir.open_from_transport(transport)
+        branch = a_dir.open_branch()
+        revno = branch.revision_id_to_revno(revision_id)
+        revision = branch.repository.get_revision(revision_id)
+        summary = 'New revision %d in %s' % (revno, url)
+        body = 'Committer: %s\n' % revision.committer
+        body += 'Date: %s\n' % format_date(revision.timestamp,
+            revision.timezone)
+        body += '\n'
+        body += revision.message
+        body = cgi.escape(body)
+        nw = pynotify.Notification(summary, body)
+        def start_viz(notification=None, action=None, data=None):
+            """Start the viz program."""
+            from bzrlib.plugins.gtk.commands import start_viz_window
+            pp = start_viz_window(branch, revision_id)
+            pp.show()
+        def start_branch(notification=None, action=None, data=None):
+            """Start a Branch dialog"""
+            from bzrlib.plugins.gtk.branch import BranchDialog
+            bd = BranchDialog(remote_path=url)
+            bd.run()
+        if "actions" in pynotify.get_server_caps():
+            nw.add_action("inspect", "Inspect", start_viz, None)
+            nw.add_action("branch", "Branch", start_branch, None)
+        show_icon()
+        gobject.timeout_add(5000, hide_icon)
+        nw.set_timeout(5000)
+        nw.show()
+    except Exception, e:
+        print e
+        raise
+bus.add_signal_receiver(catch_branch,
+                        dbus_interface=BROADCAST_INTERFACE,
+                        signal_name="Revision")
+pynotify.init("bzr-notify")
+gtk.main()

=== added file 'bzr-notify.desktop'
--- bzr-notify.desktop	1970-01-01 00:00:00 +0000
+++ bzr-notify.desktop	2011-09-28 07:45:39 +0000
@@ -0,0 +1,12 @@
+[Desktop Entry]
+Type=Application
+Version=0.1
+Name=Bazaar Notification
+GenericName=Bazaar Notification
+Comment=Notification Area Icon for Bazaar
+Icon=bzr-icon-64
+Exec=bzr-notify
+Categories=Application;Development;RevisionControl;
+Terminal=false
+X-GNOME-Autostart-Delay=30
+

=== added file 'bzr-notify.desktop.in'
--- bzr-notify.desktop.in	1970-01-01 00:00:00 +0000
+++ bzr-notify.desktop.in	2010-08-21 09:32:13 +0000
@@ -0,0 +1,10 @@
+[Desktop Entry]
+Type=Application
+Version=0.1
+_Name=Bazaar Notification
+_GenericName=Bazaar Notification
+_Comment=Notification Area Icon for Bazaar
+Icon=bzr-icon-64
+Exec=bzr-notify
+Categories=Application;Development;RevisionControl;
+Terminal=false

=== modified file 'commit.py'
--- commit.py	2012-03-22 17:14:22 +0000
+++ commit.py	2012-01-22 16:16:04 +0000
@@ -25,12 +25,9 @@
     bencode,
     errors,
     osutils,
-    revision as _mod_revision,
     trace,
-    tsort,
     )
 from bzrlib.plugins.gtk.dialog import question_dialog
-from bzrlib.plugins.gtk.diff import DiffView
 from bzrlib.plugins.gtk.errors import show_bzr_error
 from bzrlib.plugins.gtk.i18n import _i18n
 from bzrlib.plugins.gtk.commitmsgs import SavedCommitMessagesManager
@@ -43,32 +40,6 @@
     have_dbus = False
 
 
-def _get_sorted_revisions(tip_revision, revision_ids, parent_map):
-    """Get an iterator which will return the revisions in merge sorted order.
-
-    This will build up a list of all nodes, such that only nodes in the list
-    are referenced. It then uses MergeSorter to return them in 'merge-sorted'
-    order.
-
-    :param revision_ids: A set of revision_ids
-    :param parent_map: The parent information for each node. Revisions which
-        are considered ghosts should not be present in the map.
-    :return: iterator from MergeSorter.iter_topo_order()
-    """
-    # MergeSorter requires that all nodes be present in the graph, so get rid
-    # of any references pointing outside of this graph.
-    parent_graph = {}
-    for revision_id in revision_ids:
-        if revision_id not in parent_map: # ghost
-            parent_graph[revision_id] = []
-        else:
-            # Only include parents which are in this sub-graph
-            parent_graph[revision_id] = [p for p in parent_map[revision_id]
-                                            if p in revision_ids]
-    sorter = tsort.MergeSorter(parent_graph, tip_revision)
-    return sorter.iter_topo_order()
-
-
 def pending_revisions(wt):
     """Return a list of pending merges or None if there are none of them.
 
@@ -79,7 +50,7 @@
     """
     parents = wt.get_parent_ids()
     if len(parents) < 2:
-        return
+        return None
 
     # The basic pending merge algorithm uses the same algorithm as
     # bzrlib.status.show_pending_merges
@@ -87,56 +58,35 @@
     branch = wt.branch
     last_revision = parents[0]
 
-    graph = branch.repository.get_graph()
-    other_revisions = [last_revision]
+    if last_revision is not None:
+        graph = branch.repository.get_graph()
+        ignore = set([r for r,ps in graph.iter_ancestry([last_revision])])
+    else:
+        ignore = set([])
 
     pm = []
     for merge in pending:
-        try:
-            merge_rev = branch.repository.get_revision(merge)
-        except errors.NoSuchRevision:
-            # If we are missing a revision, just print out the revision id
-            trace.mutter("ghost: %r", merge)
-            other_revisions.append(merge)
-            continue
-
-        # Find all of the revisions in the merge source, which are not in the
-        # last committed revision.
-        merge_extra = graph.find_unique_ancestors(merge, other_revisions)
-        other_revisions.append(merge)
-        merge_extra.discard(_mod_revision.NULL_REVISION)
-
-        # Get a handle to all of the revisions we will need
-        try:
-            revisions = dict((rev.revision_id, rev) for rev in
-                             branch.repository.get_revisions(merge_extra))
-        except errors.NoSuchRevision:
-            # One of the sub nodes is a ghost, check each one
-            revisions = {}
-            for revision_id in merge_extra:
-                try:
-                    rev = branch.repository.get_revisions([revision_id])[0]
-                except errors.NoSuchRevision:
-                    revisions[revision_id] = None
-                else:
-                    revisions[revision_id] = rev
-
-         # Display the revisions brought in by this merge.
-        rev_id_iterator = _get_sorted_revisions(merge, merge_extra,
-                            branch.repository.get_parent_map(merge_extra))
-        # Skip the first node
-        num, first, depth, eom = rev_id_iterator.next()
-        if first != merge:
-            raise AssertionError('Somehow we misunderstood how'
-                ' iter_topo_order works %s != %s' % (first, merge))
-        children = []
-        for num, sub_merge, depth, eom in rev_id_iterator:
-            rev = revisions[sub_merge]
-            if rev is None:
-                trace.warning("ghost: %r", sub_merge)
-                continue
-            children.append(rev)
-        yield (merge_rev, children)
+        ignore.add(merge)
+        try:
+            rev = branch.repository.get_revision(merge)
+            children = []
+            pm.append((rev, children))
+
+            # This does need to be topo sorted, so we search backwards
+            inner_merges = branch.repository.get_ancestry(merge)
+            assert inner_merges[0] is None
+            inner_merges.pop(0)
+            for mmerge in reversed(inner_merges):
+                if mmerge in ignore:
+                    continue
+                rev = branch.repository.get_revision(mmerge)
+                children.append(rev)
+
+                ignore.add(mmerge)
+        except errors.NoSuchRevision:
+            print "DEBUG: NoSuchRevision:", merge
+
+    return pm
 
 
 _newline_variants_re = re.compile(r'\r\n?')
@@ -178,7 +128,7 @@
         self._delta = None
         self._wt.lock_read()
         try:
-            self._pending = list(pending_revisions(self._wt))
+            self._pending = pending_revisions(self._wt)
         finally:
             self._wt.unlock()
 
@@ -289,12 +239,7 @@
             self._check_local.hide()
             return
         if have_dbus:
-            try:
-                bus = dbus.SystemBus()
-            except dbus.DBusException:
-                trace.mutter("DBus system bus not available")
-                self._check_local.show()
-                return
+            bus = dbus.SystemBus()
             try:
                 proxy_obj = bus.get_object('org.freedesktop.NetworkManager',
                                            '/org/freedesktop/NetworkManager')
@@ -302,7 +247,7 @@
                 trace.mutter("networkmanager not available.")
                 self._check_local.show()
                 return
-
+            
             dbus_iface = dbus.Interface(proxy_obj,
                                         'org.freedesktop.NetworkManager')
             try:
@@ -334,7 +279,7 @@
         """Build up the dialog widgets."""
         # The primary pane which splits it into left and right (adjustable)
         # sections.
-        self._hpane = Gtk.Paned.new(Gtk.Orientation.HORIZONTAL)
+        self._hpane = Gtk.HPaned()
 
         self._construct_left_pane()
         self._construct_right_pane()
@@ -560,6 +505,8 @@
                                              Gtk.CellRendererText(), text=3))
 
     def _construct_diff_view(self):
+        from bzrlib.plugins.gtk.diff import DiffView
+
         # TODO: jam 2007-10-30 The diff label is currently disabled. If we
         #       decide that we really don't ever want to display it, we should
         #       actually remove it, and other references to it, along with the
@@ -574,12 +521,6 @@
         self._add_to_right_table(self._diff_view, 4, True)
         self._diff_view.show()
 
-    @staticmethod
-    def get_line_height(widget):
-        pango_layout = widget.create_pango_layout("X");
-        ink_rectangle, logical_rectangle = pango_layout.get_pixel_extents()
-        return logical_rectangle.height
-
     def _construct_file_message(self):
         scroller = Gtk.ScrolledWindow()
         scroller.set_policy(Gtk.PolicyType.AUTOMATIC, Gtk.PolicyType.AUTOMATIC)
@@ -592,8 +533,6 @@
         self._file_message_text_view.modify_font(Pango.FontDescription("Monospace"))
         self._file_message_text_view.set_wrap_mode(Gtk.WrapMode.WORD)
         self._file_message_text_view.set_accepts_tab(False)
-        line_height = self.get_line_height(self._file_message_text_view)
-        self._file_message_text_view.set_size_request(-1, line_height * 2)
         self._file_message_text_view.show()
 
         self._file_message_expander = Gtk.Expander(

=== modified file 'diff.py'
--- diff.py	2012-02-05 05:14:11 +0000
+++ diff.py	2012-01-23 21:47:33 +0000
@@ -10,8 +10,23 @@
 
 from cStringIO import StringIO
 
+import os
+import re
 import sys
 import inspect
+try:
+    from xml.etree.ElementTree import (
+        Element,
+        SubElement,
+        tostring,
+        )
+    Element, SubElement, tostring  # Hush PEP8 redefinition.
+except ImportError:
+    from elementtree.ElementTree import (
+        Element,
+        SubElement,
+        tostring,
+        )
 
 from gi.repository import Gtk
 from gi.repository import Pango
@@ -20,6 +35,11 @@
     have_gtksourceview = True
 except ImportError:
     have_gtksourceview = False
+try:
+    from gi.repository import GConf
+    have_gconf = True
+except ImportError:
+    have_gconf = False
 
 from bzrlib import (
     errors,
@@ -30,6 +50,7 @@
     )
 from bzrlib.diff import show_diff_trees
 from bzrlib.patches import parse_patches
+from bzrlib.trace import warning
 from bzrlib.plugins.gtk.dialog import (
     error_dialog,
     info_dialog,
@@ -55,8 +76,6 @@
 class DiffFileView(Gtk.ScrolledWindow):
     """Window for displaying diffs from a diff file"""
 
-    SHOW_WIDGETS = True
-
     def __init__(self):
         super(DiffFileView, self).__init__()
         self.construct()
@@ -70,18 +89,136 @@
             self.buffer = GtkSource.Buffer()
             lang_manager = GtkSource.LanguageManager.get_default()
             language = lang_manager.guess_language(None, "text/x-patch")
+            if have_gconf:
+                self.apply_gedit_colors(self.buffer)
+            self.apply_colordiff_colors(self.buffer)
             self.buffer.set_language(language)
             self.buffer.set_highlight_syntax(True)
+
             self.sourceview = GtkSource.View(buffer=self.buffer)
         else:
             self.buffer = Gtk.TextBuffer()
             self.sourceview = Gtk.TextView(self.buffer)
 
         self.sourceview.set_editable(False)
-        self.sourceview.override_font(Pango.FontDescription("Monospace"))
+        self.sourceview.modify_font(Pango.FontDescription("Monospace"))
         self.add(self.sourceview)
-        if self.SHOW_WIDGETS:
-            self.sourceview.show()
+        self.sourceview.show()
+
+    @staticmethod
+    def apply_gedit_colors(buf):
+        """Set style to that specified in gedit configuration.
+
+        This method needs the gconf module.
+
+        :param buf: a GtkSource.Buffer object.
+        """
+        GEDIT_SCHEME_PATH = '/apps/gedit-2/preferences/editor/colors/scheme'
+        GEDIT_USER_STYLES_PATH = os.path.expanduser('~/.gnome2/gedit/styles')
+
+        client = GConf.Client.get_default()
+        style_scheme_name = client.get_string(GEDIT_SCHEME_PATH)
+        if style_scheme_name is not None:
+            style_scheme_mgr = GtkSource.StyleSchemeManager()
+            style_scheme_mgr.append_search_path(GEDIT_USER_STYLES_PATH)
+
+            style_scheme = style_scheme_mgr.get_scheme(style_scheme_name)
+
+            if style_scheme is not None:
+                buf.set_style_scheme(style_scheme)
+
+    @classmethod
+    def apply_colordiff_colors(klass, buf):
+        """Set style colors for lang using the colordiff configuration file.
+
+        Both ~/.colordiffrc and ~/.colordiffrc.bzr-gtk are read.
+
+        :param buf: a "Diff" GtkSource.Buffer object.
+        """
+        scheme_manager = GtkSource.StyleSchemeManager()
+        style_scheme = scheme_manager.get_scheme('colordiff')
+
+        # if style scheme not found, we'll generate it from colordiffrc
+        # TODO: reload if colordiffrc has changed.
+        if style_scheme is None:
+            colors = {}
+
+            for f in ('~/.colordiffrc', '~/.colordiffrc.bzr-gtk'):
+                f = os.path.expanduser(f)
+                if os.path.exists(f):
+                    try:
+                        f = file(f)
+                    except IOError, e:
+                        warning('could not open file %s: %s' % (f, str(e)))
+                    else:
+                        colors.update(klass.parse_colordiffrc(f))
+                        f.close()
+
+            if not colors:
+                # ~/.colordiffrc does not exist
+                return
+
+            mapping = {
+                # map GtkSourceView2 scheme styles to colordiff names
+                # since GSV is richer, accept new names for extra bits,
+                # defaulting to old names if they're not present
+                'diff:added-line': ['newtext'],
+                'diff:removed-line': ['oldtext'],
+                'diff:location': ['location', 'diffstuff'],
+                'diff:file': ['file', 'diffstuff'],
+                'diff:special-case': ['specialcase', 'diffstuff'],
+            }
+
+            converted_colors = {}
+            for name, values in mapping.items():
+                color = None
+                for value in values:
+                    color = colors.get(value, None)
+                    if color is not None:
+                        break
+                if color is None:
+                    continue
+                converted_colors[name] = color
+
+            # some xml magic to produce needed style scheme description
+            e_style_scheme = Element('style-scheme')
+            e_style_scheme.set('id', 'colordiff')
+            e_style_scheme.set('_name', 'ColorDiff')
+            e_style_scheme.set('version', '1.0')
+            for name, color in converted_colors.items():
+                style = SubElement(e_style_scheme, 'style')
+                style.set('name', name)
+                style.set('foreground', '#%s' % color)
+
+            scheme_xml = tostring(e_style_scheme, 'UTF-8')
+            if not os.path.exists(os.path.expanduser(
+                '~/.local/share/gtksourceview-2.0/styles')):
+                os.makedirs(os.path.expanduser(
+                    '~/.local/share/gtksourceview-2.0/styles'))
+            file(os.path.expanduser(
+                '~/.local/share/gtksourceview-2.0/styles/colordiff.xml'),
+                'w').write(scheme_xml)
+
+            scheme_manager.force_rescan()
+            style_scheme = scheme_manager.get_scheme('colordiff')
+
+        buf.set_style_scheme(style_scheme)
+
+    @staticmethod
+    def parse_colordiffrc(fileobj):
+        """Parse fileobj as a colordiff configuration file.
+
+        :return: A dict with the key -> value pairs.
+        """
+        colors = {}
+        for line in fileobj:
+            if re.match(r'^\s*#', line):
+                continue
+            if '=' not in line:
+                continue
+            key, val = line.split('=', 1)
+            colors[key.strip()] = val.strip()
+        return colors
 
     def set_trees(self, rev_tree, parent_tree):
         self.rev_tree = rev_tree
@@ -298,12 +435,10 @@
     differences between two revisions on a branch.
     """
 
-    SHOW_WIDGETS = True
-
     def __init__(self, parent=None, operations=None):
         super(DiffWindow, self).__init__(parent=parent)
         self.set_border_width(0)
-        self.set_title("bzr diff")
+        self.set_title("bzrk diff")
 
         # Use two thirds of the screen by default
         screen = self.get_screen()
@@ -317,12 +452,10 @@
         """Construct the window contents."""
         self.vbox = Gtk.VBox()
         self.add(self.vbox)
-        if self.SHOW_WIDGETS:
-            self.vbox.show()
+        self.vbox.show()
         self.diff = DiffWidget()
         self.vbox.pack_end(self.diff, True, True, 0)
-        if self.SHOW_WIDGETS:
-            self.diff.show_all()
+        self.diff.show_all()
         # Build after DiffWidget to connect signals
         menubar = self._get_menu_bar()
         self.vbox.pack_start(menubar, False, False, 0)
@@ -338,11 +471,13 @@
         mb_view_wrapsource = Gtk.CheckMenuItem.new_with_mnemonic(
             _i18n("Wrap _Long Lines"))
         mb_view_wrapsource.connect('activate', self.diff._on_wraplines_toggled)
+        mb_view_wrapsource.show()
         mb_view_menu.append(mb_view_wrapsource)
+        mb_view.show()
         mb_view.set_submenu(mb_view_menu)
+        mb_view.show()
         menubar.append(mb_view)
-        if self.SHOW_WIDGETS:
-            menubar.show_all()
+        menubar.show()
         return menubar
 
     def _get_button_bar(self, operations):
@@ -356,13 +491,11 @@
         hbox.set_layout(Gtk.ButtonBoxStyle.START)
         for title, method in operations:
             merge_button = Gtk.Button(title)
-            if self.SHOW_WIDGETS:
-                merge_button.show()
+            merge_button.show()
             merge_button.set_relief(Gtk.ReliefStyle.NONE)
             merge_button.connect("clicked", method)
-            hbox.pack_start(merge_button, False, True, 0)
-        if self.SHOW_WIDGETS:
-            hbox.show()
+            hbox.pack_start(merge_button, expand=False, fill=True)
+        hbox.show()
         return hbox
 
     def _get_merge_target(self):

=== modified file 'merge.py'
--- merge.py	2012-03-11 18:24:06 +0000
+++ merge.py	2011-09-08 03:11:06 +0000
@@ -54,7 +54,7 @@
         for entry in [_i18n("Folder"),_i18n("Custom Location")]:
             self._combo_source.append_text(entry)
         self._combo_source.connect("changed", self._on_combo_changed)
-        self._button_merge = Gtk.Button(_i18n("_Merge"), use_underline=True)
+        self._button_merge = Gtk.Button(_i18n("_Merge"))
         self._button_merge_icon = Gtk.Image()
         self._button_merge_icon.set_from_stock(Gtk.STOCK_APPLY, Gtk.IconSize.BUTTON)
         self._button_merge.set_image(self._button_merge_icon)

=== modified file 'missing.py'
--- missing.py	2012-02-09 03:43:01 +0000
+++ missing.py	2011-08-13 03:06:56 +0000
@@ -47,7 +47,7 @@
 
     def _create(self):
         self.set_default_size(600, 600)
-        paned = Gtk.Paned.new(Gtk.Orientation.VERTICAL)
+        paned = Gtk.VPaned()
 
         frame = Gtk.Frame(label="You have the following extra revisions:")
 

=== modified file 'nautilus-bzr.py'
--- nautilus-bzr.py	2012-03-05 14:02:16 +0000
+++ nautilus-bzr.py	2011-12-01 10:46:10 +0000
@@ -124,12 +124,6 @@
         dialog.display()
         Gtk.main()
 
-    def push_cb(self, menu, controldir, path=None):
-        from bzrlib.plugins.gtk.push import PushDialog
-        dialog = PushDialog(branch=controldir.open_workingtree().branch)
-        dialog.display()
-        Gtk.main()
-
     def merge_cb(self, menu, tree, path=None):
         from bzrlib.plugins.gtk.merge import MergeDialog
         dialog = MergeDialog(tree, path)
@@ -245,7 +239,6 @@
             item.connect('activate', self.unignore_cb, tree, path)
             yield item
         else:
-            kind = tree.kind(file_id)
             item = Nautilus.MenuItem(name='BzrNautilus::log',
                              label='History ...',
                              tip='List changes',
@@ -275,13 +268,12 @@
             item.connect('activate', self.remove_cb, tree, path)
             yield item
 
-            if kind == 'file':
-                item = Nautilus.MenuItem(name='BzrNautilus::annotate',
-                             label='Annotate ...',
-                             tip='Annotate File Data',
-                             icon='')
-                item.connect('activate', self.annotate_cb, tree, path, file_id)
-                yield item
+            item = Nautilus.MenuItem(name='BzrNautilus::annotate',
+                         label='Annotate ...',
+                         tip='Annotate File Data',
+                         icon='')
+            item.connect('activate', self.annotate_cb, tree, path, file_id)
+            yield item
 
     def get_file_items(self, window, files):
         items = []

=== added file 'notify.py'
--- notify.py	1970-01-01 00:00:00 +0000
+++ notify.py	2012-02-03 18:59:38 +0000
@@ -0,0 +1,104 @@
+# Copyright (C) 2007 by Robert Collins
+#                       Jelmer Vernooij
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+"""Notification area icon and notification for Bazaar."""
+
+from gi.repository import Gtk
+import bzrlib
+
+
+def has_dbus():
+    return (getattr(bzrlib.plugins, "dbus", None) is not None)
+
+
+def has_avahi():
+    return (getattr(bzrlib.plugins, "avahi", None) is not None)
+
+
+class NotifyPopupMenu(Gtk.Menu):
+
+    SHOW_WIDGETS = True
+
+    def __init__(self):
+        super(NotifyPopupMenu, self).__init__()
+        self.create_items()
+
+    def create_items(self):
+        from bzrlib import errors
+        item = Gtk.CheckMenuItem.new_with_mnemonic('_Gateway to LAN')
+        item.connect('toggled', self.toggle_lan_gateway)
+        self.append(item)
+        self.append(Gtk.SeparatorMenuItem())
+        try:
+            from bzrlib.plugins.dbus.activity import LanGateway
+            self.langateway = LanGateway()
+        except ImportError:
+            item.set_sensitive(False)
+        except errors.BzrError:
+            # FIXME: Should only catch errors that indicate a lan-notify
+            # process is already running.
+            item.set_sensitive(False)
+
+        item = Gtk.CheckMenuItem.new_with_mnemonic(
+            'Announce _branches on LAN')
+        item.connect('toggled', self.toggle_announce_branches)
+        self.append(item)
+        self.append(Gtk.SeparatorMenuItem())
+        try:
+            from bzrlib.plugins.avahi.share import ZeroConfServer
+            from bzrlib import urlutils
+            self.zeroconfserver = ZeroConfServer(urlutils.normalize_url('.'))
+        except ImportError:
+            item.set_sensitive(False)
+
+        item = Gtk.ImageMenuItem.new_from_stock(Gtk.STOCK_PREFERENCES, None)
+        item.connect('activate', self.show_preferences)
+        self.append(item)
+        item = Gtk.ImageMenuItem.new_from_stock(Gtk.STOCK_ABOUT, None)
+        item.connect('activate', self.show_about)
+        self.append(item)
+        self.append(Gtk.SeparatorMenuItem())
+        item = Gtk.ImageMenuItem.new_from_stock(Gtk.STOCK_QUIT, None)
+        item.connect('activate', Gtk.main_quit)
+        self.append(item)
+        if self.SHOW_WIDGETS:
+            self.show_all()
+
+    def display(self, icon, event_button, event_time):
+        self.popup(None, None, Gtk.status_icon_position_menu,
+               event_button, event_time, icon)
+
+    def toggle_lan_gateway(self, item):
+        if item.get_active():
+            self.langateway.start()
+        else:
+            self.langateway.stop()
+
+    def toggle_announce_branches(self, item):
+        if item.get_active():
+            self.zeroconfserver.start()
+        else:
+            self.zeroconfserver.close()
+
+    def show_about(self, item):
+        from bzrlib.plugins.gtk.about import AboutDialog
+        dialog = AboutDialog()
+        dialog.run()
+
+    def show_preferences(self, item):
+        from bzrlib.plugins.gtk.preferences import PreferencesWindow
+        prefs = PreferencesWindow()
+        prefs.run()

=== modified file 'po/da.po'
--- po/da.po	2012-03-02 04:30:32 +0000
+++ po/da.po	2011-12-02 05:55:20 +0000
@@ -7,15 +7,15 @@
 msgstr ""
 "Project-Id-Version: bzr-gtk\n"
 "Report-Msgid-Bugs-To: FULL NAME <EMAIL@ADDRESS>\n"
-"POT-Creation-Date: 2011-03-06 02:19+0100\n"
-"PO-Revision-Date: 2012-03-01 17:12+0000\n"
-"Last-Translator: nanker <Unknown>\n"
+"POT-Creation-Date: 2011-12-01 11:46+0100\n"
+"PO-Revision-Date: 2011-11-30 22:59+0000\n"
+"Last-Translator: Launchpad Translations Administrators <Unknown>\n"
 "Language-Team: Danish <da@li.org>\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2012-03-02 04:30+0000\n"
-"X-Generator: Launchpad (build 14886)\n"
+"X-Launchpad-Export-Date: 2011-12-02 05:54+0000\n"
+"X-Generator: Launchpad (build 14414)\n"
 
 #: ../bazaar-properties.desktop.in.h:1
 msgid "Bazaar Preferences"
@@ -31,7 +31,7 @@
 
 #: ../bzr-handle-patch.desktop.in.h:2
 msgid "Bazaar"
-msgstr "Bazaar"
+msgstr ""
 
 #: ../bzr-notify.desktop.in.h:1
 msgid "Bazaar Notification"
@@ -60,11 +60,11 @@
 
 #: ../branch.py:53 ../checkout.py:52
 msgid "Revision:"
-msgstr "Revision:"
+msgstr ""
 
 #: ../branch.py:54 ../checkout.py:47
 msgid "Please select a folder"
-msgstr "Vælg venligst en mappe"
+msgstr ""
 
 #: ../branch.py:134 ../checkout.py:153
 msgid "Missing branch location"
@@ -106,7 +106,7 @@
 
 #: ../commands.py:306
 msgid "Operation aborted."
-msgstr "Operation afbrudt."
+msgstr ""
 
 #: ../commands.py:410
 msgid "There are local changes in the branch"
@@ -122,19 +122,19 @@
 
 #: ../commit.py:179
 msgid "removed"
-msgstr "fjernet"
+msgstr ""
 
 #: ../commit.py:180
 msgid "renamed"
-msgstr "omdøbt"
+msgstr ""
 
 #: ../commit.py:181
 msgid "renamed and modified"
-msgstr "omdøbt og ændret"
+msgstr ""
 
 #: ../commit.py:182
 msgid "modified"
-msgstr "ændret"
+msgstr ""
 
 #: ../commit.py:183
 msgid "kind changed"
@@ -178,7 +178,7 @@
 
 #: ../commit.py:443 ../conflicts.py:107
 msgid "Path"
-msgstr "Sti"
+msgstr ""
 
 #: ../commit.py:445 ../conflicts.py:109
 msgid "Type"
@@ -194,7 +194,7 @@
 
 #: ../commit.py:503
 msgid "Date"
-msgstr "Dato"
+msgstr ""
 
 #: ../commit.py:505
 msgid "Committer"
@@ -202,7 +202,7 @@
 
 #: ../commit.py:507 ../search.py:60
 msgid "Summary"
-msgstr "Oversigt"
+msgstr ""
 
 #. TODO: jam 2007-10-30 The diff label is currently disabled. If we
 #. decide that we really don't ever want to display it, we should
@@ -272,7 +272,7 @@
 
 #: ../conflicts.py:97
 msgid "Conflicts"
-msgstr "Konflikter"
+msgstr ""
 
 #: ../conflicts.py:100
 msgid "No conflicts in working tree."
@@ -316,7 +316,7 @@
 
 #: ../conflicts.py:132
 msgid "unknown type of conflict"
-msgstr "ukendt type af konflikt"
+msgstr ""
 
 #: ../conflicts.py:161
 msgid "No file was selected"
@@ -324,7 +324,7 @@
 
 #: ../conflicts.py:162
 msgid "Please select a file from the list."
-msgstr "Vælg venligst en fil fra listen."
+msgstr ""
 
 #: ../conflicts.py:172
 msgid "Call to external utility failed"
@@ -332,7 +332,7 @@
 
 #: ../conflicts.py:174
 msgid "Cannot resolve conflict"
-msgstr "Kan ikke løse konflikt"
+msgstr ""
 
 #: ../conflicts.py:175
 msgid ""
@@ -569,6 +569,46 @@
 msgid "Bazaar command error"
 msgstr ""
 
+#: ../nautilus-bzr.py:460
+msgid "File id:"
+msgstr ""
+
+#: ../nautilus-bzr.py:463
+msgid "SHA1Sum:"
+msgstr ""
+
+#: ../nautilus-bzr.py:469
+msgid "Last Change Revision:"
+msgstr ""
+
+#: ../nautilus-bzr.py:474
+msgid "Last Change Author:"
+msgstr ""
+
+#: ../nautilus-bzr.py:515
+msgid "Push location:"
+msgstr ""
+
+#: ../nautilus-bzr.py:518
+msgid "Parent location:"
+msgstr ""
+
+#: ../nautilus-bzr.py:521
+msgid "Bound location:"
+msgstr ""
+
+#: ../nautilus-bzr.py:524
+msgid "Public location:"
+msgstr ""
+
+#: ../nautilus-bzr.py:527
+msgid "Submit location:"
+msgstr ""
+
+#: ../nautilus-bzr.py:530
+msgid "Append revisions only"
+msgstr ""
+
 #. Create the widgets
 #: ../push.py:50
 msgid "Location:"

=== modified file 'po/de.po'
--- po/de.po	2012-01-01 05:55:28 +0000
+++ po/de.po	2011-12-02 05:55:20 +0000
@@ -8,34 +8,34 @@
 "Project-Id-Version: olive\n"
 "Report-Msgid-Bugs-To: FULL NAME <EMAIL@ADDRESS>\n"
 "POT-Creation-Date: 2011-12-01 11:46+0100\n"
-"PO-Revision-Date: 2011-12-31 16:09+0000\n"
-"Last-Translator: Daniel Winzen <d@winzen4.de>\n"
+"PO-Revision-Date: 2011-11-30 22:58+0000\n"
+"Last-Translator: Jelmer Vernooij <Unknown>\n"
 "Language-Team: German <de@li.org>\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2012-01-01 05:55+0000\n"
-"X-Generator: Launchpad (build 14560)\n"
+"X-Launchpad-Export-Date: 2011-12-02 05:55+0000\n"
+"X-Generator: Launchpad (build 14414)\n"
 
 #: ../bazaar-properties.desktop.in.h:1
 msgid "Bazaar Preferences"
-msgstr "Bazaar-Einstellungen"
+msgstr ""
 
 #: ../bazaar-properties.desktop.in.h:2
 msgid "Configure Bazaar settings"
-msgstr "Bazaar-Einstellungen konfigurieren"
+msgstr ""
 
 #: ../bzr-handle-patch.desktop.in.h:1
 msgid "Apply Bazaar Bundle"
-msgstr "Bazaarpaket anwenden"
+msgstr ""
 
 #: ../bzr-handle-patch.desktop.in.h:2
 msgid "Bazaar"
-msgstr "Bazaar"
+msgstr ""
 
 #: ../bzr-notify.desktop.in.h:1
 msgid "Bazaar Notification"
-msgstr "Bazaar-Benachrichtigungen"
+msgstr ""
 
 #: ../bzr-notify.desktop.in.h:2
 msgid "Notification Area Icon for Bazaar"
@@ -154,7 +154,7 @@
 
 #: ../commit.py:388
 msgid "Files"
-msgstr "Dateien"
+msgstr ""
 
 #: ../commit.py:393
 msgid "Commit all changes"
@@ -672,11 +672,11 @@
 
 #: ../search.py:41
 msgid "Search for:"
-msgstr "Suche nach:"
+msgstr ""
 
 #: ../search.py:56
 msgid "Document"
-msgstr "Dokument"
+msgstr ""
 
 #: ../status.py:87
 msgid "Added"

=== modified file 'po/ja.po'
--- po/ja.po	2012-02-12 05:08:39 +0000
+++ po/ja.po	2011-12-02 05:55:20 +0000
@@ -8,18 +8,18 @@
 "Project-Id-Version: bzr-gtk\n"
 "Report-Msgid-Bugs-To: FULL NAME <EMAIL@ADDRESS>\n"
 "POT-Creation-Date: 2011-12-01 11:46+0100\n"
-"PO-Revision-Date: 2012-02-11 12:20+0000\n"
-"Last-Translator: Koichi Akabe <vbkaisetsu@gmail.com>\n"
+"PO-Revision-Date: 2011-11-30 23:01+0000\n"
+"Last-Translator: Fumihito YOSHIDA <hito@kugutsu.org>\n"
 "Language-Team: Japanese <ja@li.org>\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2012-02-12 05:08+0000\n"
-"X-Generator: Launchpad (build 14771)\n"
+"X-Launchpad-Export-Date: 2011-12-02 05:55+0000\n"
+"X-Generator: Launchpad (build 14414)\n"
 
 #: ../bazaar-properties.desktop.in.h:1
 msgid "Bazaar Preferences"
-msgstr "Bazaar 設定"
+msgstr ""
 
 #: ../bazaar-properties.desktop.in.h:2
 msgid "Configure Bazaar settings"
@@ -31,11 +31,11 @@
 
 #: ../bzr-handle-patch.desktop.in.h:2
 msgid "Bazaar"
-msgstr "Bazaar"
+msgstr ""
 
 #: ../bzr-notify.desktop.in.h:1
 msgid "Bazaar Notification"
-msgstr "Bazaar 通知"
+msgstr ""
 
 #: ../bzr-notify.desktop.in.h:2
 msgid "Notification Area Icon for Bazaar"
@@ -142,7 +142,7 @@
 
 #: ../commit.py:276
 msgid "<b>Commit Message</b>"
-msgstr "<b>コミットメッセージ</b>"
+msgstr ""
 
 #: ../commit.py:329
 msgid "_Only commit locally"
@@ -158,11 +158,11 @@
 
 #: ../commit.py:393
 msgid "Commit all changes"
-msgstr "すべての変更をコミット"
+msgstr ""
 
 #: ../commit.py:399
 msgid "Only commit selected changes"
-msgstr "選択した変更のみコミット"
+msgstr ""
 
 #: ../commit.py:405
 msgid "Commit all changes*"
@@ -247,7 +247,7 @@
 
 #: ../commit.py:707
 msgid "You can describe your commit intent in the message."
-msgstr "コミット内容をメッセージで説明できます。"
+msgstr ""
 
 #: ../commit.py:727
 msgid "Commit with unknowns?"

=== modified file 'po/sv.po'
--- po/sv.po	2012-02-22 06:51:43 +0000
+++ po/sv.po	2011-12-02 05:55:20 +0000
@@ -8,14 +8,14 @@
 "Project-Id-Version: olive\n"
 "Report-Msgid-Bugs-To: FULL NAME <EMAIL@ADDRESS>\n"
 "POT-Creation-Date: 2011-12-01 11:46+0100\n"
-"PO-Revision-Date: 2012-02-21 16:04+0000\n"
-"Last-Translator: Rikard Edgren <Unknown>\n"
+"PO-Revision-Date: 2011-11-30 22:59+0000\n"
+"Last-Translator: Daniel Nylander <yeager@ubuntu.com>\n"
 "Language-Team: Swedish <sv@li.org>\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2012-02-22 06:51+0000\n"
-"X-Generator: Launchpad (build 14838)\n"
+"X-Launchpad-Export-Date: 2011-12-02 05:55+0000\n"
+"X-Generator: Launchpad (build 14414)\n"
 
 #: ../bazaar-properties.desktop.in.h:1
 msgid "Bazaar Preferences"
@@ -48,7 +48,7 @@
 
 #: ../branch.py:49 ../checkout.py:49
 msgid "Branch location:"
-msgstr "Grenens plats:"
+msgstr ""
 
 #: ../branch.py:51 ../checkout.py:50
 msgid "Destination:"
@@ -56,11 +56,11 @@
 
 #: ../branch.py:52
 msgid "Branck nick:"
-msgstr "Grenens kortnamn:"
+msgstr ""
 
 #: ../branch.py:53 ../checkout.py:52
 msgid "Revision:"
-msgstr "Version:"
+msgstr "Revision:"
 
 #: ../branch.py:54 ../checkout.py:47
 msgid "Please select a folder"
@@ -68,29 +68,29 @@
 
 #: ../branch.py:134 ../checkout.py:153
 msgid "Missing branch location"
-msgstr "Grenens plats saknas"
+msgstr ""
 
 #: ../branch.py:135 ../checkout.py:154
 msgid "You must specify a branch location."
-msgstr "Du måste ange en plats för grenen."
+msgstr ""
 
 #: ../branch.py:174
 msgid "Branching successful"
-msgstr "Förgrening lyckades"
+msgstr "Grening lyckades"
 
 #: ../branch.py:175
 #, python-format
 msgid "%d revision(s) branched."
-msgstr "%d version(er) förgrenade."
+msgstr "%d revision(er) grenade."
 
 #: ../branch.py:183 ../checkout.py:185
 msgid "N/A"
-msgstr "Inte tillgänglig"
+msgstr ""
 
 #. Create the widgets
 #: ../checkout.py:44
 msgid "Check_out"
-msgstr "Checka_ut"
+msgstr ""
 
 #: ../checkout.py:51
 msgid "Branch nick:"
@@ -98,15 +98,15 @@
 
 #: ../checkout.py:56
 msgid "_Lightweight checkout"
-msgstr "_Lätt utcheckning"
+msgstr ""
 
 #: ../commands.py:305
 msgid "Directory does not have a working tree"
-msgstr "Katalogen innehåller inte något arbetsträd"
+msgstr "Katalogen innehåller inte ett arbetsträd"
 
 #: ../commands.py:306
 msgid "Operation aborted."
-msgstr "Åtgärden avbröts."
+msgstr "Åtgärden avbruten."
 
 #: ../commands.py:410
 msgid "There are local changes in the branch"
@@ -130,7 +130,7 @@
 
 #: ../commit.py:181
 msgid "renamed and modified"
-msgstr "omdöpt och ändrad"
+msgstr ""
 
 #: ../commit.py:182
 msgid "modified"
@@ -268,39 +268,39 @@
 
 #: ../conflicts.py:45
 msgid "External utility:"
-msgstr "Externt verktyg:"
+msgstr ""
 
 #: ../conflicts.py:97
 msgid "Conflicts"
-msgstr "Konflikter"
+msgstr ""
 
 #: ../conflicts.py:100
 msgid "No conflicts in working tree."
-msgstr "Inga konflikter i arbetsträd."
+msgstr ""
 
 #: ../conflicts.py:114
 msgid "path conflict"
-msgstr "sökvägskonflikt"
+msgstr ""
 
 #: ../conflicts.py:116
 msgid "contents conflict"
-msgstr "innehållskonflikt"
+msgstr ""
 
 #: ../conflicts.py:118
 msgid "text conflict"
-msgstr "textkonflikt"
+msgstr ""
 
 #: ../conflicts.py:120
 msgid "duplicate id"
-msgstr "duplicera id"
+msgstr ""
 
 #: ../conflicts.py:122
 msgid "duplicate"
-msgstr "duplicera"
+msgstr ""
 
 #: ../conflicts.py:124
 msgid "parent loop"
-msgstr "överordnad loop"
+msgstr ""
 
 #: ../conflicts.py:126
 msgid "unversioned parent"
@@ -316,7 +316,7 @@
 
 #: ../conflicts.py:132
 msgid "unknown type of conflict"
-msgstr "okänd konflikttyp"
+msgstr ""
 
 #: ../conflicts.py:161
 msgid "No file was selected"
@@ -324,15 +324,15 @@
 
 #: ../conflicts.py:162
 msgid "Please select a file from the list."
-msgstr "Välj en fil från listan."
+msgstr ""
 
 #: ../conflicts.py:172
 msgid "Call to external utility failed"
-msgstr "Anrop till externt verktyg misslyckades"
+msgstr ""
 
 #: ../conflicts.py:174
 msgid "Cannot resolve conflict"
-msgstr "Kan inte lösa konflikt"
+msgstr ""
 
 #: ../conflicts.py:175
 msgid ""
@@ -353,16 +353,16 @@
 #. No conflicts found.
 #: ../diff.py:493 ../merge.py:144
 msgid "Merge successful"
-msgstr "Sammanslagningen lyckades"
+msgstr ""
 
 #: ../diff.py:494 ../merge.py:145
 msgid "All changes applied successfully."
-msgstr "Alla ändringar har aktiverats utan problem."
+msgstr ""
 
 #. There are conflicts to be resolved.
 #: ../diff.py:497 ../merge.py:148
 msgid "Conflicts encountered"
-msgstr "Konflikter uppkom."
+msgstr ""
 
 #: ../diff.py:498 ../merge.py:149
 msgid "Please resolve the conflicts manually before committing."
@@ -374,7 +374,7 @@
 
 #: ../errors.py:32
 msgid "You can perform this action only in a branch."
-msgstr "Du kan endast genomföra denna operation i en gren."
+msgstr ""
 
 #: ../errors.py:34
 msgid "Directory is not a checkout"
@@ -417,8 +417,6 @@
 "There are unknown files in the working tree.\n"
 "Please add or delete them."
 msgstr ""
-"Det finns okända filer i arbetsträdet.\n"
-"Lägg till eller radera dem."
 
 #: ../errors.py:49
 msgid "Bound branch is out of date"
@@ -450,7 +448,7 @@
 
 #: ../errors.py:59
 msgid "No diff output"
-msgstr "Ingen utdata från diff"
+msgstr ""
 
 #: ../errors.py:60
 msgid "The selected file hasn't changed."
@@ -458,7 +456,7 @@
 
 #: ../errors.py:62
 msgid "No such revision"
-msgstr "Ingen sådan version"
+msgstr ""
 
 #: ../errors.py:63
 msgid "The revision you specified doesn't exist."
@@ -470,7 +468,7 @@
 
 #: ../errors.py:66
 msgid "Target directory already exists. Please select another target."
-msgstr "Målkatalogen existerar redan. Välj ett annat mål."
+msgstr ""
 
 #: ../errors.py:68
 msgid "Directory is already a branch"
@@ -482,12 +480,10 @@
 "The current directory (%s) is already a branch.\n"
 "You can start using it, or initialize another directory."
 msgstr ""
-"Den aktuella katalogen (%s) är redan en gren.\n"
-"Du kan börja använda den, eller initiera en ny katalog."
 
 #: ../errors.py:71
 msgid "Branch without a working tree"
-msgstr "Gren utan arbetsträd"
+msgstr ""
 
 #: ../errors.py:72
 #, python-format
@@ -495,12 +491,10 @@
 "The current directory (%s)\n"
 "is a branch without a working tree."
 msgstr ""
-"Den nuvarande katalogen (%s)\n"
-"är en gren utan arbetsträd."
 
 #: ../errors.py:74
 msgid "Unknown bzr error"
-msgstr "Okänt bzr-fel"
+msgstr ""
 
 #: ../errors.py:76
 msgid "Permission denied"
@@ -508,7 +502,7 @@
 
 #: ../errors.py:76
 msgid "permission denied."
-msgstr "åtkomst nekad."
+msgstr ""
 
 #: ../errors.py:78
 msgid "Unknown error"
@@ -521,23 +515,23 @@
 
 #: ../initialize.py:47
 msgid "Which directory do you want to initialize?"
-msgstr "Vilken mapp vill du initalisera?"
+msgstr ""
 
 #: ../initialize.py:49
 msgid "Current directory"
-msgstr "Nuvarande katalog"
+msgstr ""
 
 #: ../initialize.py:51
 msgid "Create a new directory with the name:"
-msgstr "Skapa en ny katalog med namnet:"
+msgstr ""
 
 #: ../initialize.py:87
 msgid "Directory name not specified"
-msgstr "Katalognamn ej specificerat"
+msgstr ""
 
 #: ../initialize.py:88
 msgid "You should specify a new directory name."
-msgstr "Du bör specificera ett nytt katalognamn."
+msgstr ""
 
 #: ../loom.py:49
 msgid "Upgrade to Loom branch?"
@@ -569,11 +563,11 @@
 
 #: ../merge.py:131
 msgid "Please specify a branch to merge from."
-msgstr "Ange en gren att slå samman med."
+msgstr ""
 
 #: ../merge.py:139
 msgid "Bazaar command error"
-msgstr "Bazaar kommando-fel"
+msgstr ""
 
 #: ../nautilus-bzr.py:460
 msgid "File id:"
@@ -641,7 +635,7 @@
 
 #: ../push.py:141
 msgid "Non existing parent directory"
-msgstr "Ingen existerande överordnad katalog"
+msgstr ""
 
 #: ../push.py:142
 #, python-format
@@ -690,23 +684,23 @@
 #. Set properties
 #: ../tags.py:60
 msgid "Tags"
-msgstr "Etiketter"
+msgstr ""
 
 #: ../tags.py:110
 msgid "Tag Name"
-msgstr "Etikett-namn"
+msgstr ""
 
 #: ../tags.py:115
 msgid "Revision ID"
-msgstr "Versions-ID"
+msgstr ""
 
 #: ../tags.py:148
 msgid "Tags are not supported by this branch format. Please upgrade."
-msgstr "Etiketter stöds ej i detta gren-format. Vänligen uppgradera."
+msgstr ""
 
 #: ../tags.py:154
 msgid "No tagged revisions in the branch."
-msgstr "Inga versioner med etiketter i denna gren."
+msgstr ""
 
 #: ../tags.py:222
 msgid "_Remove tag"
@@ -732,7 +726,7 @@
 
 #: ../tags.py:281
 msgid "Revision ID:"
-msgstr "Versions-ID:"
+msgstr ""
 
 #: ../tags.py:312
 msgid "No tag name specified"

=== modified file 'preferences/plugins.py'
--- preferences/plugins.py	2012-02-09 03:43:01 +0000
+++ preferences/plugins.py	2012-02-03 18:08:07 +0000
@@ -17,11 +17,10 @@
 from gi.repository import Gtk
 
 
-class PluginsPage(Gtk.Paned):
+class PluginsPage(Gtk.VPaned):
 
     def __init__(self):
         super(PluginsPage, self).__init__()
-        self.set_orientation(Gtk.Orientation.VERTICAL)
         self.set_border_width(12)
         self.set_position(216)
 

=== modified file 'push.py'
--- push.py	2012-03-11 21:41:49 +0000
+++ push.py	2011-09-05 03:44:26 +0000
@@ -1,5 +1,4 @@
-# Copyright (C) 2006 by Szilveszter Farkas (Phanatic)
-#                       <szilveszter.farkas@gmail.com>
+# Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
 # Copyright (C) 2007 by Jelmer Vernooij <jelmer@samba.org>
 #
 # This program is free software; you can redistribute it and/or modify
@@ -16,73 +15,61 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
+from gi.repository import GObject
 from gi.repository import Gtk
 
 from errors import show_bzr_error
 
-from bzrlib import (
-    errors,
-    ui,
-    )
-from bzrlib.controldir import ControlDir
-from bzrlib.push import PushResult
-from bzrlib.transport import get_transport
+import bzrlib.errors as errors
 
 from bzrlib.plugins.gtk.dialog import (
+    info_dialog,
     question_dialog,
     )
+
 from bzrlib.plugins.gtk.history import UrlHistory
 from bzrlib.plugins.gtk.i18n import _i18n
-from bzrlib.plugins.gtk.ui import ProgressPanel
 
 
 class PushDialog(Gtk.Dialog):
     """New implementation of the Push dialog."""
 
-    def __init__(self, repository=None, revid=None, branch=None, parent=None):
+    def __init__(self, repository, revid, branch=None, parent=None):
         """Initialize the Push dialog. """
         super(PushDialog, self).__init__(
-            title="Push", parent=parent, flags=0, border_width=6,
-            buttons=(Gtk.STOCK_CLOSE, Gtk.ResponseType.CLOSE))
-        if repository is None:
-            repository = branch.repository
-        self.branch = branch
-
-        # Unused arguments
+            title="Push", parent=parent, flags=0,
+            buttons=(Gtk.STOCK_CANCEL, Gtk.ResponseType.CANCEL))
+
+
+        # Get arguments
         self.repository = repository
-        if revid is None:
-            revid = branch.last_revision()
         self.revid = revid
+        self.branch = branch
 
         # Create the widgets
         self._label_location = Gtk.Label(label=_i18n("Location:"))
         self._combo = Gtk.ComboBox.new_with_entry()
         self._button_push = Gtk.Button(_i18n("_Push"), use_underline=True)
-        self._hbox_location = Gtk.Box(Gtk.Orientation.HORIZONTAL, 6)
-        self._push_message = Gtk.Label(xalign=0)
-        self._progress_widget = ProgressPanel()
+        self._hbox_location = Gtk.HBox()
 
         # Set callbacks
-        ui.ui_factory.set_progress_bar_widget(self._progress_widget)
-        self.connect('close', self._on_close_clicked)
         self._button_push.connect('clicked', self._on_push_clicked)
 
         # Set properties
-        content_area = self.get_content_area()
-        content_area.set_spacing(6)
+        self._label_location.set_alignment(0, 0.5)
+        self._hbox_location.set_spacing(3)
+        self.get_content_area().set_spacing(3)
 
         # Pack widgets
-        self._hbox_location.pack_start(self._label_location, False, False, 0)
-        self._hbox_location.pack_start(self._combo, False, False, 0)
-        content_area.pack_start(self._hbox_location, True, True, 0)
-        content_area.pack_start(self._progress_widget, True, True, 0)
-        content_area.pack_start(self._push_message, True, True, 0)
+        self._hbox_location.pack_start(
+            self._label_location, False, False, 0)
+        self._hbox_location.pack_start(self._combo, True, True, 0)
+        self.get_content_area().pack_start(self._hbox_location, True, True, 0)
+        # XXX sinzui 2011-08-12: maybe False, False, 0
         self.get_action_area().pack_end(self._button_push, True, True, 0)
 
         # Show the dialog
-        content_area.show_all()
-        self._progress_widget.hide()
-        self._push_message.hide()
+        self.get_content_area().show_all()
 
         # Build location history
         self._history = UrlHistory(self.branch.get_config(), 'push_history')
@@ -92,7 +79,7 @@
         """Build up the location history. """
         self._combo_model = Gtk.ListStore(str)
         for item in self._history.get_entries():
-            self._combo_model.append([item])
+            self._combo_model.append([ item ])
         self._combo.set_model(self._combo_model)
         self._combo.set_entry_text_column(0)
 
@@ -101,36 +88,28 @@
             if location is not None:
                 self._combo.get_child().set_text(location)
 
-    def _on_close_clicked(self, widget):
-        """Close dialog handler."""
-        ui.ui_factory.set_progress_bar_widget(None)
-
     @show_bzr_error
     def _on_push_clicked(self, widget):
         """Push button clicked handler. """
-        self._push_message.hide()
-        self._progress_widget.tick()
         location = self._combo.get_child().get_text()
+        revs = 0
 
         try:
-            message = do_push(self.branch, location, overwrite=False)
+            revs = do_push(self.branch, location=location, overwrite=False)
         except errors.DivergedBranches:
-            response = question_dialog(
-                _i18n('Branches have been diverged'),
-                _i18n('You cannot push if branches have diverged.\n'
-                      'Overwrite?'))
+            response = question_dialog(_i18n('Branches have been diverged'),
+                                       _i18n('You cannot push if branches have diverged.\nOverwrite?'))
             if response == Gtk.ResponseType.YES:
-                message = do_push(self.branch, location, overwrite=True)
-            else:
-                return
+                revs = do_push(self.branch, location=location, overwrite=True)
+
+        if self.branch is not None and self.branch.get_push_location() is None:
+            self.branch.set_push_location(location)
+
         self._history.add_entry(location)
-        if (self.branch is not None
-            and self.branch.get_push_location() is None):
-            self.branch.set_push_location(location)
-        if message:
-            self._progress_widget.finished()
-            self._push_message.props.label = message
-            self._push_message.show()
+        info_dialog(_i18n('Push successful'),
+                    _i18n("%d revision(s) pushed.") % revs)
+
+        self.response(Gtk.ResponseType.OK)
 
 
 def do_push(br_from, location, overwrite):
@@ -141,62 +120,44 @@
     :param overwrite: overwrite target location if it diverged
     :return: number of revisions pushed
     """
-    revision_id = None
-    to_transport = get_transport(location)
+    from bzrlib.bzrdir import BzrDir
+    from bzrlib.transport import get_transport
+
+    transport = get_transport(location)
+    location_url = transport.base
+
+    old_rh = []
+
     try:
-        dir_to = ControlDir.open_from_transport(to_transport)
+        dir_to = BzrDir.open(location_url)
+        br_to = dir_to.open_branch()
     except errors.NotBranchError:
-        dir_to = None
-
-    if dir_to is None:
+        # create a branch.
+        transport = transport.clone('..')
         try:
-            br_to = br_from.create_clone_on_transport(
-                to_transport, revision_id=revision_id)
+            relurl = transport.relpath(location_url)
+            transport.mkdir(relurl)
         except errors.NoSuchFile:
-            response = question_dialog(
-                _i18n('Non existing parent directory'),
-                _i18n("The parent directory (%s)\ndoesn't exist. Create?") %
-                    location)
+            response = question_dialog(_i18n('Non existing parent directory'),
+                         _i18n("The parent directory (%s)\ndoesn't exist. Create?") % location)
             if response == Gtk.ResponseType.OK:
-                br_to = br_from.create_clone_on_transport(
-                    to_transport, revision_id=revision_id, create_prefix=True)
+                transport.create_prefix()
             else:
-                return _i18n("Push aborted.")
-        push_result = create_push_result(br_from, br_to)
+                return
+        dir_to = br_from.bzrdir.clone(location_url,
+            revision_id=br_from.last_revision())
+        br_to = dir_to.open_branch()
+        count = len(br_to.revision_history())
     else:
-        push_result = dir_to.push_branch(br_from, revision_id, overwrite)
-    message = create_push_message(br_from, push_result)
-    return message
-
-
-def create_push_message(br_from, push_result):
-    """Return a mesage explaining what happened during the push."""
-    messages = []
-    rev_count = br_from.revno() - push_result.old_revno
-    messages.append(_i18n("%d revision(s) pushed.") % rev_count)
-    if push_result.stacked_on is not None:
-        messages.append(_i18n("Stacked on %s.") % push_result.stacked_on)
-    if push_result.workingtree_updated is False:
-        messages.append(_i18n(
-            "\nThe working tree was not updated:"
-            "\nSee 'bzr help working-trees' for more information."))
-    return '\n'.join(messages)
-
-
-def create_push_result(br_from, br_to):
-    """Return a PushResult like one created by ControlDir.push_branch()."""
-    push_result = PushResult()
-    push_result.source_branch = br_from
-    push_result.target_branch = br_to
-    push_result.branch_push_result = None
-    push_result.master_branch = None
-    push_result.old_revno = 0
-    push_result.old_revid = br_to.last_revision()
-    push_result.workingtree_updated = None  # Not applicable to this case.
-    try:
-        push_result.stacked_on = br_to.get_stacked_on_url()
-    except (errors.UnstackableBranchFormat,
-            errors.UnstackableRepositoryFormat,
-            errors.NotStacked):
-        push_result.stacked_on = None
-    return push_result
+        old_rh = br_to.revision_history()
+        try:
+            tree_to = dir_to.open_workingtree()
+        except errors.NotLocalUrl:
+            # FIXME - what to do here? how should we warn the user?
+            count = br_to.pull(br_from, overwrite)
+        except errors.NoWorkingTree:
+            count = br_to.pull(br_from, overwrite)
+        else:
+            count = tree_to.pull(br_from, overwrite)
+
+    return count

=== modified file 'setup.py'
--- setup.py	2012-07-09 15:23:26 +0000
+++ setup.py	2011-11-06 00:49:02 +0000
@@ -1,47 +1,33 @@
 #!/usr/bin/python
 """GTK+ Frontends for various Bazaar commands."""
 
-import os
-import sys
-
-from info import bzr_plugin_version
+from info import *
 
 from distutils.core import setup, Command
 from distutils.command.install_data import install_data
 from distutils.command.build import build
 from distutils.command.sdist import sdist
 try:
-    from DistUtilsExtra.command import build_i18n
+    from DistUtilsExtra.command import *
 except ImportError:
-    # Python distutils extra is not available.
-    class cmd_build_i18n(build):
-        user_options = []
-
-        def initialize_options(self):
-            self.domain = None
-            self.desktop_files = None
-
-        def finalize_options(self):
-            pass
-
+   # Python distutils extra is not available.
+    class cmd_build_i18n(Command):
         def run(self):
-            print >> sys.stderr, (
-                "For internationalization support you'll need to install "
-                "https://launchpad.net/python-distutils-extra")
+            print >> sys.stderr, "For internationalization support you'll need to install https://launchpad.net/python-distutils-extra"
 else:
     # Use build_i18n from DistUtilsExtra
     cmd_build_i18n = build_i18n.build_i18n
 
+import os
+import sys
 
 class Check(Command):
     description = "Run unit tests"
 
-    user_options = [
-        ('module=', 'm', 'The test module to run'),
-        ]
+    user_options = []
 
     def initialize_options(self):
-        self.module = None
+        pass
 
     def finalize_options(self):
         pass
@@ -52,12 +38,11 @@
     def run(self):
         from bzrlib.tests import TestLoader, TestSuite, TextTestRunner
         from bzrlib.plugin import PluginImporter
-        PluginImporter.specific_paths["bzrlib.plugins.gtk"] = os.path.dirname(
-            __file__)
+        PluginImporter.specific_paths["bzrlib.plugins.gtk"] = os.path.dirname(__file__)
         from bzrlib.plugins.gtk.tests import load_tests
         suite = TestSuite()
         loader = TestLoader()
-        load_tests(suite, self.module, loader)
+        load_tests(suite, None, loader)
         runner = TextTestRunner()
         result = runner.run(suite)
         return result.wasSuccessful()
@@ -78,8 +63,7 @@
         return 'build_credits'
 
     def run(self):
-        from bzrlib.plugin import load_plugins
-        load_plugins()
+        from bzrlib.plugin import load_plugins; load_plugins()
         from bzrlib.branch import Branch
         from bzrlib.plugins.stats.cmds import find_credits
 
@@ -142,15 +126,15 @@
     version = bzr_plugin_version[:3]
     version_string = ".".join([str(x) for x in version])
     setup(
-        name="bzr-gtk",
-        version=version_string,
-        maintainer="Jelmer Vernooij",
-        maintainer_email="jelmer@samba.org",
-        description="GTK+ Frontends for various Bazaar commands",
-        license="GNU GPL v2 or later",
-        scripts=['bzr-handle-patch'],
-        url="http://bazaar-vcs.org/BzrGtk",
-        package_dir={
+        name = "bzr-gtk",
+        version = version_string,
+        maintainer = "Jelmer Vernooij",
+        maintainer_email = "jelmer@samba.org",
+        description = "GTK+ Frontends for various Bazaar commands",
+        license = "GNU GPL v2 or later",
+        scripts = ['bzr-handle-patch', 'bzr-notify'],
+        url = "http://bazaar-vcs.org/BzrGtk",
+        package_dir = {
             "bzrlib.plugins.gtk": ".",
             "bzrlib.plugins.gtk.viz": "viz",
             "bzrlib.plugins.gtk.annotate": "annotate",
@@ -158,7 +142,7 @@
             "bzrlib.plugins.gtk.branchview": "branchview",
             "bzrlib.plugins.gtk.preferences": "preferences",
             },
-        packages=[
+        packages = [
             "bzrlib.plugins.gtk",
             "bzrlib.plugins.gtk.viz",
             "bzrlib.plugins.gtk.annotate",
@@ -166,7 +150,7 @@
             "bzrlib.plugins.gtk.branchview",
             "bzrlib.plugins.gtk.preferences",
         ],
-        data_files=[('share/bzr-gtk', ['credits.pickle']),
+        data_files=[ ('share/bzr-gtk', ['credits.pickle']),
                     ('share/bzr-gtk/icons', ['icons/commit.png',
                                              'icons/commit16.png',
                                              'icons/diff.png',
@@ -188,11 +172,11 @@
                     # In case Python distutils extra is not available,
                     # install the .desktop files
                     ('share/applications', ['bazaar-properties.desktop',
-                                            'bzr-handle-patch.desktop']),
+                                            'bzr-handle-patch.desktop',
+                                            'bzr-notify.desktop']),
                     ('share/application-registry', ['bzr-gtk.applications']),
                     ('share/pixmaps', ['icons/bzr-icon-64.png']),
-                    ('share/icons/hicolor/scalable/apps',
-                        ['icons/bzr-panel.svg']),
+                    ('share/icons/hicolor/scalable/apps', ['icons/bzr-panel.svg']),
                     ('share/icons/hicolor/scalable/emblems',
                      ['icons/emblem-bzr-added.svg',
                       'icons/emblem-bzr-conflict.svg',

=== modified file 'tags.py'
--- tags.py	2012-02-09 03:43:01 +0000
+++ tags.py	2011-09-05 03:44:26 +0000
@@ -15,6 +15,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
+from gi.repository import GObject
 from gi.repository import Gtk
 
 from bzrlib.plugins.gtk.dialog import error_dialog
@@ -46,7 +47,7 @@
         self._vbox_buttons = Gtk.VBox()
         self._vbox_buttons_top = Gtk.VBox()
         self._vbox_buttons_bottom = Gtk.VBox()
-        self._vpaned = Gtk.Paned.new(Gtk.Orientation.VERTICAL)
+        self._vpaned = Gtk.VPaned()
 
         # Set callbacks
         self._button_add.connect('clicked', self._on_add_clicked)
@@ -197,8 +198,6 @@
         # Refresh RevisionView only if there are tags available
         if not self._no_tags:
             (path, col) = self._treeview_tags.get_cursor()
-            if path is None:
-                return  # The widget is being destroyed.
             revision = self._model[path][1]
             self._revisionview.set_revision(self.branch.repository.get_revision(revision))
 

=== modified file 'tests/__init__.py'
--- tests/__init__.py	2012-03-04 00:09:11 +0000
+++ tests/__init__.py	2012-02-03 18:59:38 +0000
@@ -14,77 +14,40 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-__all__ = [
-    'load_tests',
-    'MockMethod',
-    'MockProperty',
-    ]
-
-import os
-
-
-def discover_test_names(module_or_name):
-    if isinstance(module_or_name, basestring):
-        match = module_or_name
-    else:
-        match = ''
-    file_names = os.listdir(os.path.dirname(__file__))
-    test_names = set()
-    for file_name in file_names:
-        name, ext = os.path.splitext(file_name)
-        if name.startswith('test_') and ext == '.py' and match in name:
-            test_names.add("%s.%s" % (__name__, name))
-    return test_names
-
 
 def load_tests(basic_tests, module, loader):
-    test_names = discover_test_names(module)
-    basic_tests.addTest(loader.loadTestsFromModuleNames(test_names))
+    testmod_names = [
+        'test_annotate_config',
+        'test_avatarsbox',
+        'test_commit',
+        'test_diff',
+        'test_history',
+        'test_graphcell',
+        'test_linegraph',
+        'test_notify',
+        'test_revisionview',
+        'test_treemodel',
+        ]
+
+    basic_tests.addTest(loader.loadTestsFromModuleNames(
+            ["%s.%s" % (__name__, tmn) for tmn in testmod_names]))
     return basic_tests
 
 
-class MockMethod(object):
+class MockMethod():
 
     @classmethod
-    def bind(klass, test_instance, obj, method_name,
-             return_value=None, raise_error=None, raise_on=1):
+    def bind(klass, test_instance, obj, method_name):
         original_method = getattr(obj, method_name)
         test_instance.addCleanup(setattr, obj, method_name, original_method)
-        setattr(obj, method_name, klass(return_value, raise_error, raise_on))
+        setattr(obj, method_name, klass())
 
-    def __init__(self, return_value=None, raise_error=None, raise_on=1):
+    def __init__(self):
         self.called = False
-        self.call_count = 0
         self.args = None
         self.kwargs = None
-        self.return_value = return_value
-        self.raise_error = raise_error
-        self.raise_on = raise_on
 
     def __call__(self, *args, **kwargs):
         self.called = True
-        self.call_count += 1
         self.args = args
         self.kwargs = kwargs
-        if self.raise_error is not None and self.call_count == self.raise_on:
-            raise self.raise_error
-        return self.return_value
-
-
-class MockProperty(MockMethod):
-
-    @classmethod
-    def bind(klass, test_instance, obj, method_name, return_value=None):
-        original_method = getattr(obj, method_name)
-        test_instance.addCleanup(setattr, obj, method_name, original_method)
-        mock = klass(return_value)
-        setattr(obj, method_name, property(mock.get_value, mock.set_value))
-        return mock
-
-    def get_value(self, other):
-        self.called = True
-        return self.return_value
-
-    def set_value(self, other, value):
-        self.called = True
-        self.return_value = value

=== modified file 'tests/test_annotate_config.py'
--- tests/test_annotate_config.py	2012-02-09 03:01:20 +0000
+++ tests/test_annotate_config.py	2011-09-04 03:53:20 +0000
@@ -16,8 +16,6 @@
 
 """Test the annotate configuration functionality."""
 
-import os
-
 from bzrlib import (
     tests,
     )
@@ -26,7 +24,6 @@
     config,
     gannotate,
     )
-from bzrlib.plugins.gtk.annotate.config import gannotate_config_filename
 
 
 class TestConfig(tests.TestCaseInTempDir):
@@ -48,15 +45,3 @@
         width = conf['window']['width']
         # configobj presents attributes as strings only
         self.assertIsInstance(width, str)
-
-    def test_write(self):
-        """The window state and pane position is saved."""
-        conf = config.GAnnotateConfig(self.window)
-        self.window.pane.set_position(200)
-        self.assertIs(False, conf._write())
-        self.assertEqual(200, conf['window']['pane_position'])
-        config_path = gannotate_config_filename()
-        self.assertIs(True, os.path.isfile(config_path))
-        with open(config_path) as config_file:
-            config_data = config_file.read()
-        self.assertIn('pane_position = 200', config_data)

=== modified file 'tests/test_commit.py'
--- tests/test_commit.py	2012-03-22 17:14:22 +0000
+++ tests/test_commit.py	2012-01-23 16:52:40 +0000
@@ -17,8 +17,6 @@
 """Test the Commit functionality."""
 
 import os
-import subprocess
-from tempfile import NamedTemporaryFile
 
 from gi.repository import Gtk
 
@@ -51,7 +49,7 @@
         tree.commit('one')
 
         self.addCleanup(tree.lock_read().unlock)
-        self.assertEquals([], list(commit.pending_revisions(tree)))
+        self.assertIs(None, commit.pending_revisions(tree))
 
     def test_pending_revisions_simple(self):
         tree = self.make_branch_and_tree('tree')
@@ -62,7 +60,7 @@
         self.assertEqual([rev_id1, rev_id2], tree.get_parent_ids())
 
         self.addCleanup(tree.lock_read().unlock)
-        pending_revisions = list(commit.pending_revisions(tree))
+        pending_revisions = commit.pending_revisions(tree)
         # One primary merge
         self.assertEqual(1, len(pending_revisions))
         # Revision == rev_id2
@@ -81,7 +79,7 @@
         self.assertEqual([rev_id1, rev_id4], tree.get_parent_ids())
 
         self.addCleanup(tree.lock_read().unlock)
-        pending_revisions = list(commit.pending_revisions(tree))
+        pending_revisions = commit.pending_revisions(tree)
         # One primary merge
         self.assertEqual(1, len(pending_revisions))
         # Revision == rev_id2
@@ -105,7 +103,7 @@
         self.assertEqual([rev_id1, rev_id3, rev_id5], tree.get_parent_ids())
 
         self.addCleanup(tree.lock_read().unlock)
-        pending_revisions = list(commit.pending_revisions(tree))
+        pending_revisions = commit.pending_revisions(tree)
         # Two primary merges
         self.assertEqual(2, len(pending_revisions))
         # Revision == rev_id2
@@ -174,7 +172,7 @@
 
         dlg = CommitDialogNoWidgets(tree)
         self.assertEqual(rev_id, dlg._basis_tree.get_revision_id())
-        self.assertEquals([], dlg._pending)
+        self.assertIs(None, dlg._pending)
         self.assertFalse(dlg._is_checkout)
 
     def test_setup_parameters_checkout(self):
@@ -185,7 +183,7 @@
 
         dlg = CommitDialogNoWidgets(tree2)
         self.assertEqual(rev_id, dlg._basis_tree.get_revision_id())
-        self.assertEquals([], dlg._pending)
+        self.assertIs(None, dlg._pending)
         self.assertTrue(dlg._is_checkout)
 
     def test_setup_parameters_pending(self):
@@ -235,13 +233,6 @@
         dlg._on_treeview_files_cursor_changed(treeview)
         self.assertFalse(CommitDialogNoWidgets._update_per_file_info.called)
 
-    def test_get_line_height(self):
-        tree = self.make_branch_and_tree('tree')
-        dlg = CommitDialogNoWidgets(tree)
-        textview = Gtk.TextView()
-        line_height = dlg.get_line_height(textview)
-        self.assertIsInstance(line_height, int)
-
 
 class TestCommitDialog(tests.TestCaseWithTransport):
 
@@ -1305,32 +1296,3 @@
         self.assertEquals(u'', self._get_commit_message())
         self.assertEquals(u'de',
                           self._get_file_commit_messages())
-
-
-class BzrHandlePatchTestCase(tests.TestCase):
-
-    def setUp(self):
-        top = os.path.abspath(os.path.join(
-            os.path.dirname(__file__), os.pardir))
-        self.script = os.path.join(top, 'bzr-handle-patch')
-        self.env = dict(os.environ)
-        self.env['BZR_PLUGINS_AT'] = 'gtk@%s' % top
-        self.patch = NamedTemporaryFile()
-        self.patch.write('\n'.join([
-            "=== added file '_test.txt'",
-            "--- _test.txt	1970-01-01 00:00:00 +0000",
-            "+++ _test.txt	2012-02-03 20:00:34 +0000",
-            "@@ -0,0 +1,1 @@",
-            "+hello",
-            ]))
-        self.patch.flush()
-        super(BzrHandlePatchTestCase, self).setUp()
-
-    def test_smoketest(self):
-        # This is a smoke test to verify the process starts.
-        bzr_notify = subprocess.Popen(
-            [self.script, self.patch.name, 'test'],
-            stdout=subprocess.PIPE, stderr=subprocess.PIPE, env=self.env)
-        stdout, stderr = bzr_notify.communicate()
-        self.assertEqual('', stdout)
-        self.assertEqual('', stderr)

=== modified file 'tests/test_diff.py'
--- tests/test_diff.py	2012-02-05 05:14:11 +0000
+++ tests/test_diff.py	2012-01-23 18:10:44 +0000
@@ -15,6 +15,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
+from cStringIO import StringIO
 import os
 
 from gi.repository import Gtk
@@ -32,11 +33,8 @@
 
 from bzrlib.plugins.gtk.diff import (
     DiffController,
-    DiffFileView,
     DiffView,
     DiffWidget,
-    DiffWindow,
-    have_gtksourceview,
     iter_changes_to_status,
     MergeDirectiveController,
     )
@@ -62,29 +60,24 @@
  class TestDiffViewSimple(tests.TestCase):
 """
 
-
-class FakeDiffFileView(DiffFileView):
-
-    SHOW_WIDGETS = False
-
-
-class DiffFileViewTestCase(tests.TestCase):
-
-    def test_init_construct(self):
-        view = FakeDiffFileView()
-        self.assertIsNot(None, view.buffer)
-        self.assertIsNot(None, view.sourceview)
-        self.assertIs(False, view.sourceview.props.editable)
-        font_desc = view.sourceview.get_style_context().get_font(
-            Gtk.StateFlags.NORMAL)
-        self.assertIn('Monospace', font_desc.get_family())
-
-    def test_init_construct_have_gtksourceview(self):
-        if not have_gtksourceview:
-            return
-        view = FakeDiffFileView()
-        self.assertEqual('Diff', view.buffer.get_language().get_name())
-        self.assertIs(True, view.buffer.get_highlight_syntax())
+class TestDiffViewSimple(tests.TestCase):
+
+    def test_parse_colordiffrc(self):
+        colordiffrc = '''\
+newtext=blue
+oldtext = Red
+# now a comment and a blank line
+
+diffstuff = #ffff00  
+  # another comment preceded by whitespace
+'''
+        colors = {
+                'newtext': 'blue',
+                'oldtext': 'Red',
+                'diffstuff': '#ffff00',
+        }
+        parsed_colors = DiffView.parse_colordiffrc(StringIO(colordiffrc))
+        self.assertEqual(colors, parsed_colors)
 
 
 class TestDiffView(tests.TestCaseWithTransport):
@@ -138,65 +131,6 @@
         self.assertFalse(widget.diff_view.show_diff.called)
 
 
-class FakeDiffWindow(DiffWindow):
-
-    SHOW_WIDGETS = False
-
-
-class DiffWindowTestCase(tests.TestCaseWithTransport):
-
-    def test_init(self):
-        window = DiffWindow()
-        self.assertEqual('bzr diff', window.props.title)
-        self.assertEqual(0, window.props.border_width)
-
-    def test_init_construct_without_operations(self):
-        window = DiffWindow()
-        widgets = window.vbox.get_children()
-        self.assertEqual(2, len(widgets))
-        self.assertIsInstance(widgets[0], Gtk.MenuBar)
-        self.assertIsInstance(widgets[1], DiffWidget)
-
-    def test_init_construct_with_operations(self):
-        method = MockMethod()
-        window = DiffWindow(operations=[('title', method)])
-        widgets = window.vbox.get_children()
-        self.assertEqual(3, len(widgets))
-        self.assertIsInstance(widgets[0], Gtk.MenuBar)
-        self.assertIsInstance(widgets[1], Gtk.HButtonBox)
-        self.assertIsInstance(widgets[2], DiffWidget)
-
-    def test_get_menu_bar(self):
-        window = DiffWindow()
-        menu_bar = window._get_menu_bar()
-        self.assertIsNot(None, menu_bar)
-        menus = menu_bar.get_children()
-        self.assertEqual(1, len(menus))
-        self.assertEqual('_View', menus[0].props.label)
-        sub_menu = menus[0].get_submenu()
-        self.assertIsNot(None, sub_menu)
-        items = sub_menu.get_children()
-        self.assertEqual(1, len(items))
-        menus[0].get_submenu().get_children()[0].props.label
-        self.assertEqual('Wrap _Long Lines', items[0].props.label)
-
-    def test_get_button_bar_with_none(self):
-        window = DiffWindow()
-        self.assertIs(None, window._get_button_bar(None))
-
-    def test_get_button_bar_with_operations(self):
-        window = DiffWindow()
-        method = MockMethod()
-        button_bar = window._get_button_bar([('title', method)])
-        self.assertIsNot(None, button_bar)
-        buttons = button_bar.get_children()
-        self.assertEqual(1, len(buttons))
-        self.assertEqual('title', buttons[0].props.label)
-        buttons[0].emit('clicked')
-        self.assertIs(True, method.called)
-
-
-
 class MockDiffWidget(object):
 
     def set_diff_text_sections(self, sections):

=== modified file 'tests/test_notify.py'
--- tests/test_notify.py	2012-02-19 15:00:34 +0000
+++ tests/test_notify.py	2012-02-03 18:59:38 +0000
@@ -15,8 +15,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-import os
-import subprocess
+from gi.repository import Gtk
 
 from bzrlib import tests
 from bzrlib.plugins.gtk.notify import NotifyPopupMenu
@@ -27,6 +26,8 @@
     SHOW_WIDGETS = False
 
 
+# ['_Gateway to LAN', '', 'Announce _branches on LAN', '', 'gtk-preferences', 'gtk-about', '', 'gtk-quit']
+
 class NotifyPopupMenuTestCase(tests.TestCase):
 
     def test_init(self):
@@ -38,27 +39,3 @@
         self.assertEqual('gtk-preferences', items[4].props.label)
         self.assertEqual('gtk-about', items[5].props.label)
         self.assertEqual('gtk-quit', items[7].props.label)
-
-
-class BzrNotifyTestCase(tests.TestCase):
-
-    def setUp(self):
-        top = os.path.abspath(os.path.join(
-            os.path.dirname(__file__), os.pardir))
-        self.script = os.path.join(top, 'bzr-notify')
-        self.env = dict(os.environ)
-        self.env['BZR_PLUGINS_AT'] = 'gtk@%s' % top
-        super(BzrNotifyTestCase, self).setUp()
-
-    def test_smoketest(self):
-        # This is a smoke test to verify the process starts.
-        # The logic of the module must be moved into notify.py
-        # where it can be properly tested.
-        bzr_notify = subprocess.Popen(
-            [self.script, 'test'],
-            stdout=subprocess.PIPE, stderr=subprocess.PIPE, env=self.env)
-        stdout, stderr = bzr_notify.communicate()
-        self.assertEqual('', stdout)
-        self.assertTrue(
-            stderr in (
-            '', 'ERROR:root:Could not find any typelib for AppIndicator3\n'))

=== removed file 'tests/test_push.py'
--- tests/test_push.py	2012-03-20 12:39:08 +0000
+++ tests/test_push.py	1970-01-01 00:00:00 +0000
@@ -1,230 +0,0 @@
-# Copyright (C) 2012 Curtis Hovey <sinzui.is@verizon.net>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Test the ui functionality."""
-
-from gi.repository import Gtk
-
-from bzrlib import (
-    errors,
-    tests,
-    ui,
-    )
-
-from bzrlib.plugins.gtk import (
-    push,
-    set_ui_factory,
-    )
-from bzrlib.plugins.gtk.tests import MockMethod
-from bzrlib.plugins.gtk.history import UrlHistory
-from bzrlib.plugins.gtk.ui import ProgressPanel
-
-
-class PushTestCase(tests.TestCaseWithMemoryTransport):
-
-    def make_push_branch(self):
-        tree = self.make_branch_and_memory_tree('test')
-        return tree.branch
-
-    def test_init(self):
-        set_ui_factory()
-        branch = self.make_push_branch()
-        dialog = push.PushDialog(
-            repository=None, revid=None, branch=branch, parent=None)
-        self.assertIs(None, dialog.props.parent)
-        self.assertIs(branch.repository, dialog.repository)
-        self.assertIs(branch.last_revision(), dialog.revid)
-        self.assertIs(branch, dialog.branch)
-        # Layout rules to match HIG.
-        self.assertIsInstance(dialog._label_location, Gtk.Label)
-        self.assertIsInstance(dialog._combo, Gtk.ComboBox)
-        self.assertIsInstance(dialog._button_push, Gtk.Button)
-        self.assertIsInstance(dialog._hbox_location, Gtk.Box)
-        self.assertIsInstance(dialog._progress_widget, ProgressPanel)
-        self.assertIsInstance(dialog._push_message, Gtk.Label)
-        self.assertIsInstance(dialog._history, UrlHistory)
-        self.assertIs(
-            ui.ui_factory._progress_bar_widget, dialog._progress_widget)
-        self.assertEqual(
-            Gtk.Orientation.HORIZONTAL,
-            dialog._hbox_location.props.orientation)
-        self.assertEqual(0.0, dialog._push_message.props.xalign)
-        self.assertEqual(6, dialog.props.border_width)
-        self.assertEqual(6, dialog._hbox_location.props.spacing)
-        self.assertEqual(6, dialog.get_content_area().props.spacing)
-        # Show rules.
-        self.assertIs(True, dialog._combo.props.visible)
-        self.assertIs(False, dialog._progress_widget.props.visible)
-        self.assertIs(False, dialog._push_message.props.visible)
-
-    def test_build_history(self):
-        set_ui_factory()
-        branch = self.make_push_branch()
-        branch.set_push_location('lp:~user/fnord/trunk')
-        dialog = push.PushDialog(None, None, branch)
-        dialog._history.add_entry('lp:~user/fnord/test1')
-        dialog._history.add_entry('lp:~user/fnord/test2')
-        dialog._build_history()
-        self.assertEqual(
-            'lp:~user/fnord/trunk', dialog._combo.get_child().props.text)
-        self.assertIsInstance(dialog._combo_model, Gtk.ListStore)
-        self.assertIs(dialog._combo.get_model(), dialog._combo_model)
-        locations = [row[0] for row in dialog._combo_model]
-        self.assertEqual(
-            ['lp:~user/fnord/test1', 'lp:~user/fnord/test2'], locations)
-
-    def test_on_close_clicked(self):
-        # The ui_factory's progress bar widget is set to None.
-        set_ui_factory()
-        branch = self.make_push_branch()
-        dialog = push.PushDialog(None, None, branch)
-        dialog._on_close_clicked(None)
-        self.assertIs(None, ui.ui_factory._progress_bar_widget)
-
-    def test_on_push_clicked_without_errors(self):
-        # Verify the dialog's and branch's final states after a push.
-        MockMethod.bind(self, push, 'do_push', "test success")
-        set_ui_factory()
-        branch = self.make_push_branch()
-        dialog = push.PushDialog(None, None, branch)
-        MockMethod.bind(self, dialog._progress_widget, 'tick')
-        dialog._combo.get_child().props.text = 'lp:~user/fnord/test'
-        dialog._on_push_clicked(None)
-        self.assertIs(True, dialog._progress_widget.tick.called)
-        self.assertIs(False, dialog._progress_widget.props.visible)
-        self.assertIs(True, push.do_push.called)
-        self.assertEqual(
-            (branch, 'lp:~user/fnord/test'), push.do_push.args)
-        self.assertEqual(
-            {'overwrite': False}, push.do_push.kwargs)
-        self.assertIs(True, dialog._push_message.props.visible)
-        self.assertEqual('test success', dialog._push_message.props.label)
-        self.assertEqual(
-            'lp:~user/fnord/test', dialog._history.get_entries()[-1])
-        self.assertEqual('lp:~user/fnord/test', branch.get_push_location())
-
-    def test_on_push_clicked_with_divered_branches(self):
-        # Verify that when DivergedBranches is raise, the user can choose
-        # to overwrite the branch.
-        error = errors.DivergedBranches(None, None)
-        MockMethod.bind(self, push, 'do_push', raise_error=error)
-        MockMethod.bind(self, push, 'question_dialog', Gtk.ResponseType.YES)
-        set_ui_factory()
-        branch = self.make_push_branch()
-        dialog = push.PushDialog(None, None, branch)
-        dialog._combo.get_child().props.text = 'lp:~user/fnord/test'
-        dialog._on_push_clicked(None)
-        self.assertIs(True, push.do_push.called)
-        self.assertEqual(2, push.do_push.call_count)
-        self.assertEqual(
-            (branch, 'lp:~user/fnord/test'), push.do_push.args)
-        self.assertEqual(
-            {'overwrite': True}, push.do_push.kwargs)
-
-
-class DoPushTestCase(tests.TestCaseWithTransport):
-
-    def setup_ui(self):
-        set_ui_factory()
-        progress_panel = ProgressPanel()
-        ui.ui_factory.set_progress_bar_widget(progress_panel)
-        MockMethod.bind(self, progress_panel.pb, 'tick')
-        MockMethod.bind(self, progress_panel.pb, 'update')
-        MockMethod.bind(self, progress_panel.pb, 'finished')
-        return progress_panel
-
-    def make_from_branch(self):
-        from_tree = self.make_branch_and_tree('this')
-        self.build_tree(['this/a', 'this/b'])
-        from_tree.add(['a', 'b'])
-        from_tree.commit("msg")
-        return from_tree.branch
-
-    def test_do_push_without_dir(self):
-        progress_panel = self.setup_ui()
-        from_branch = self.make_from_branch()
-        message = push.do_push(from_branch, 'that', False)
-        self.assertEqual('1 revision(s) pushed.', message)
-        self.assertEqual(True, progress_panel.pb.update.called)
-        self.assertEqual(True, progress_panel.pb.finished.called)
-
-    def test_do_push_without_parent_dir(self):
-        progress_panel = self.setup_ui()
-        from_branch = self.make_from_branch()
-        MockMethod.bind(self, push, 'question_dialog', Gtk.ResponseType.OK)
-        message = push.do_push(from_branch, 'that/there', False)
-        self.assertEqual('1 revision(s) pushed.', message)
-        self.assertEqual(True, push.question_dialog.called)
-        self.assertEqual(True, progress_panel.pb.update.called)
-        self.assertEqual(True, progress_panel.pb.finished.called)
-
-    def test_do_push_without_parent_dir_aborted(self):
-        self.setup_ui()
-        from_branch = self.make_from_branch()
-        MockMethod.bind(self, push, 'question_dialog', Gtk.ResponseType.CANCEL)
-        message = push.do_push(from_branch, 'that/there', False)
-        self.assertEqual('Push aborted.', message)
-
-    def test_do_push_with_dir(self):
-        progress_panel = self.setup_ui()
-        self.make_branch_and_tree('that')
-        from_branch = self.make_from_branch()
-        message = push.do_push(from_branch, 'that', False)
-        self.assertEqual('1 revision(s) pushed.', message)
-        self.assertEqual(True, progress_panel.pb.update.called)
-        self.assertEqual(True, progress_panel.pb.finished.called)
-
-    def test_create_push_result_unstacked(self):
-        from_branch = object()
-        to_branch = self.make_branch_and_tree('that').branch
-        push_result = push.create_push_result(from_branch, to_branch)
-        self.assertIs(from_branch, push_result.source_branch)
-        self.assertIs(to_branch, push_result.target_branch)
-        self.assertIs(None, push_result.branch_push_result)
-        self.assertIs(None, push_result.master_branch)
-        self.assertEqual(0, push_result.old_revno)
-        self.assertEqual(to_branch.last_revision(), push_result.old_revid)
-        self.assertIs(None, push_result.workingtree_updated)
-        self.assertIs(None, push_result.stacked_on)
-
-    def test_create_push_result_stacked(self):
-        from_branch = object()
-        to_branch = self.make_branch_and_tree('that').branch
-        MockMethod.bind(self, to_branch, 'get_stacked_on_url', 'lp:project')
-        push_result = push.create_push_result(from_branch, to_branch)
-        self.assertEqual('lp:project', push_result.stacked_on)
-
-    def test_create_push_message_stacked_on(self):
-        from_branch = object()
-        to_branch = self.make_branch_and_tree('that').branch
-        MockMethod.bind(self, to_branch, 'get_stacked_on_url', 'lp:project')
-        push_result = push.create_push_result(from_branch, to_branch)
-        from_branch = self.make_from_branch()
-        message = push.create_push_message(from_branch, push_result)
-        self.assertEqual(
-            '1 revision(s) pushed.\nStacked on lp:project.', message)
-
-    def test_create_push_message_workingtree_updated_false(self):
-        from_branch = object()
-        to_branch = self.make_branch_and_tree('that').branch
-        push_result = push.create_push_result(from_branch, to_branch)
-        push_result.workingtree_updated = False
-        from_branch = self.make_from_branch()
-        message = push.create_push_message(from_branch, push_result)
-        self.assertEqual(
-            "1 revision(s) pushed.\n\nThe working tree was not updated:\n"
-            "See 'bzr help working-trees' for more information.",
-            message)

=== removed file 'tests/test_ui.py'
--- tests/test_ui.py	2012-02-28 04:53:55 +0000
+++ tests/test_ui.py	1970-01-01 00:00:00 +0000
@@ -1,375 +0,0 @@
-# Copyright (C) 2012 Curtis Hovey <sinzui.is@verizon.net>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Test the ui functionality."""
-
-from gi.repository import Gtk
-
-from bzrlib import (
-    tests,
-    )
-
-from bzrlib.plugins.gtk import ui
-from bzrlib.plugins.gtk.tests import (
-    MockMethod,
-    MockProperty,
-    )
-from bzrlib.progress import ProgressTask
-
-
-class MainIterationTestCase(tests.TestCase):
-
-    def test_main_iteration(self):
-        # The main_iteration decorator iterates over the pending Gtk events
-        # after calling its function so that the UI is updated too.
-        button = Gtk.ToggleButton(label='before')
-
-        def event_listener(button):
-            button.props.label = 'after'
-
-        button.connect('clicked', event_listener)
-
-        def test_func(self):
-            button.emit('clicked')
-            return True
-
-        decorated_func = ui.main_iteration(test_func)
-        result = decorated_func(object())
-        self.assertIs(True, result)
-        self.assertIs(False, Gtk.events_pending())
-        self.assertEqual('after', button.props.label)
-
-
-class PromptDialogTestCase(tests.TestCase):
-
-    def test_init(self):
-        # The text and buttons are created.
-        dialog = ui.PromptDialog('test 123')
-        self.assertEqual('test 123', dialog.props.text)
-        self.assertEqual(Gtk.MessageType.QUESTION, dialog.props.message_type)
-        buttons = dialog.get_action_area().get_children()
-        self.assertEqual('gtk-yes', buttons[0].props.label)
-        self.assertEqual('gtk-no', buttons[1].props.label)
-
-
-class InfoDialogTestCase(tests.TestCase):
-
-    def test_init(self):
-        # The text and buttons are created.
-        dialog = ui.InfoDialog('test 123')
-        self.assertEqual('test 123', dialog.props.text)
-        self.assertEqual(Gtk.MessageType.INFO, dialog.props.message_type)
-        buttons = dialog.get_action_area().get_children()
-        self.assertEqual('gtk-close', buttons[0].props.label)
-
-
-class WarningDialogTestCase(tests.TestCase):
-
-    def test_init(self):
-        # The text and buttons are created.
-        dialog = ui.WarningDialog('test 123')
-        self.assertEqual('test 123', dialog.props.text)
-        self.assertEqual(Gtk.MessageType.WARNING, dialog.props.message_type)
-        buttons = dialog.get_action_area().get_children()
-        self.assertEqual('gtk-close', buttons[0].props.label)
-
-
-class ErrorDialogTestCase(tests.TestCase):
-
-    def test_init(self):
-        # The text and buttons are created, then shown.
-        dialog = ui.ErrorDialog('test 123')
-        self.assertEqual('test 123', dialog.props.text)
-        self.assertEqual(Gtk.MessageType.ERROR, dialog.props.message_type)
-        buttons = dialog.get_action_area().get_children()
-        self.assertEqual('gtk-close', buttons[0].props.label)
-
-
-class PasswordDialogTestCase(tests.TestCase):
-
-    def test_init(self):
-        # The label, password entry, and buttons are created, then shown.
-        MockMethod.bind(self, Gtk.Box, 'show_all')
-        dialog = ui.PasswordDialog('test password')
-        content_area = dialog.get_content_area()
-        self.assertIs(True, dialog.get_content_area().show_all.called)
-        widgets = content_area.get_children()
-        self.assertEqual('test password', widgets[0].props.label)
-        self.assertEqual(False, widgets[1].props.visibility)
-        buttons = dialog.get_action_area().get_children()
-        self.assertEqual('gtk-cancel', buttons[0].props.label)
-        self.assertEqual(
-            Gtk.ResponseType.CANCEL,
-            dialog.get_response_for_widget(buttons[0]))
-        self.assertEqual('gtk-ok', buttons[1].props.label)
-        self.assertEqual(
-            Gtk.ResponseType.OK,
-            dialog.get_response_for_widget(buttons[1]))
-
-
-class GtkProgressBarTestCase(tests.TestCase):
-
-    def test_init(self):
-        progress_bar = ui.GtkProgressBar()
-        self.assertEqual(0.0, progress_bar.props.fraction)
-        self.assertIs(None, progress_bar.total)
-        self.assertIs(None, progress_bar.current)
-
-    def test_tick(self):
-        # tick() shows the widget, does one pulse, then handles the pending
-        # events in the main loop.
-        MockMethod.bind(self, ui.GtkProgressBar, 'show')
-        MockMethod.bind(self, ui.GtkProgressBar, 'pulse')
-        progress_bar = ui.GtkProgressBar()
-        progress_bar.tick()
-        self.assertIs(True, progress_bar.show.called)
-        self.assertEqual('with_main_iteration', progress_bar.tick.__name__)
-
-    def test_update_with_data(self):
-        # update() shows the widget, sets the fraction, then handles the
-        # pending events in the main loop.
-        MockMethod.bind(self, ui.GtkProgressBar, 'show')
-        progress_bar = ui.GtkProgressBar()
-        progress_bar.update(msg='test', current_cnt=5, total_cnt=10)
-        self.assertIs(True, progress_bar.show.called)
-        self.assertEqual(0.5, progress_bar.props.fraction)
-        self.assertEqual(10, progress_bar.total)
-        self.assertEqual(5, progress_bar.current)
-        self.assertEqual('with_main_iteration', progress_bar.update.__name__)
-
-    def test_update_without_data(self):
-        progress_bar = ui.GtkProgressBar()
-        progress_bar.update(current_cnt=5, total_cnt=None)
-        self.assertEqual(0.0, progress_bar.props.fraction)
-        self.assertIs(None, progress_bar.total)
-        self.assertEqual(5, progress_bar.current)
-
-    def test_update_with_insane_data(self):
-        # The fraction must be between 0.0 and 1.0.
-        progress_bar = ui.GtkProgressBar()
-        self.assertRaises(
-            ValueError, progress_bar.update, None, 20, 2)
-
-    def test_finished(self):
-        # finished() hides the widget, resets the state, then handles the
-        # pending events in the main loop.
-        MockMethod.bind(self, ui.GtkProgressBar, 'hide')
-        progress_bar = ui.GtkProgressBar()
-        progress_bar.finished()
-        self.assertIs(True, progress_bar.hide.called)
-        self.assertEqual(0.0, progress_bar.props.fraction)
-        self.assertIs(None, progress_bar.total)
-        self.assertIs(None, progress_bar.current)
-        self.assertEqual('with_main_iteration', progress_bar.finished.__name__)
-
-    def test_clear(self):
-        # clear() is synonymous with finished.
-        MockMethod.bind(self, ui.GtkProgressBar, 'finished')
-        progress_bar = ui.GtkProgressBar()
-        progress_bar.finished()
-        self.assertIs(True, progress_bar.finished.called)
-
-
-class ProgressContainerMixin:
-
-    def test_tick(self):
-        progress_widget = self.progress_container()
-        MockMethod.bind(self, progress_widget, 'show_all')
-        MockMethod.bind(self, progress_widget.pb, 'tick')
-        progress_widget.tick()
-        self.assertIs(True, progress_widget.show_all.called)
-        self.assertIs(True, progress_widget.pb.tick.called)
-
-    def test_update(self):
-        progress_widget = self.progress_container()
-        MockMethod.bind(self, progress_widget, 'show_all')
-        MockMethod.bind(self, progress_widget.pb, 'update')
-        progress_widget.update('test', 5, 10)
-        self.assertIs(True, progress_widget.show_all.called)
-        self.assertIs(True, progress_widget.pb.update.called)
-        self.assertEqual(
-            ('test', 5, 10), progress_widget.pb.update.args)
-
-    def test_finished(self):
-        progress_widget = self.progress_container()
-        MockMethod.bind(self, progress_widget, 'hide')
-        MockMethod.bind(self, progress_widget.pb, 'finished')
-        progress_widget.finished()
-        self.assertIs(True, progress_widget.hide.called)
-        self.assertIs(True, progress_widget.pb.finished.called)
-
-    def test_clear(self):
-        progress_widget = self.progress_container()
-        MockMethod.bind(self, progress_widget, 'hide')
-        MockMethod.bind(self, progress_widget.pb, 'clear')
-        progress_widget.clear()
-        self.assertIs(True, progress_widget.hide.called)
-        self.assertIs(True, progress_widget.pb.clear.called)
-
-
-class ProgressBarWindowTestCase(ProgressContainerMixin, tests.TestCase):
-
-    progress_container = ui.ProgressBarWindow
-
-    def test_init(self):
-        pb_window = ui.ProgressBarWindow()
-        self.assertEqual('Progress', pb_window.props.title)
-        self.assertEqual(
-            Gtk.WindowPosition.CENTER_ALWAYS, pb_window.props.window_position)
-        self.assertIsInstance(pb_window.pb, ui.GtkProgressBar)
-
-
-class ProgressPanelTestCase(ProgressContainerMixin, tests.TestCase):
-
-    progress_container = ui.ProgressPanel
-
-    def test_init(self):
-        pb_window = ui.ProgressPanel()
-        self.assertEqual(
-            Gtk.Orientation.HORIZONTAL, pb_window.props.orientation)
-        self.assertEqual(5, pb_window.props.spacing)
-        self.assertIsInstance(pb_window.pb, ui.GtkProgressBar)
-        widgets = pb_window.get_children()
-        # The image's stock and icon_name properties are always None?
-        self.assertIsInstance(widgets[0], Gtk.Image)
-
-
-class GtkUIFactoryTestCase(tests.TestCase):
-
-    def test__init(self):
-        ui_factory = ui.GtkUIFactory()
-        self.assertIs(None, ui_factory._progress_bar_widget)
-
-    def test_set_progress_bar_widget(self):
-        ui_factory = ui.GtkUIFactory()
-        progress_widget = ui.ProgressPanel()
-        ui_factory.set_progress_bar_widget(progress_widget)
-        self.assertIs(progress_widget, ui_factory._progress_bar_widget)
-
-    def test_get_boolean_true(self):
-        ui_factory = ui.GtkUIFactory()
-        MockMethod.bind(self, ui.PromptDialog, 'run', Gtk.ResponseType.YES)
-        boolean_value = ui_factory.get_boolean('test')
-        self.assertIs(True, ui.PromptDialog.run.called)
-        self.assertIs(True, boolean_value)
-
-    def test_get_boolean_false(self):
-        ui_factory = ui.GtkUIFactory()
-        MockMethod.bind(self, ui.PromptDialog, 'run', Gtk.ResponseType.NO)
-        boolean_value = ui_factory.get_boolean('test')
-        self.assertIs(True, ui.PromptDialog.run.called)
-        self.assertIs(False, boolean_value)
-
-    def test_show_message(self):
-        ui_factory = ui.GtkUIFactory()
-        MockMethod.bind(self, ui.InfoDialog, 'run', Gtk.ResponseType.CLOSE)
-        ui_factory.show_message('test')
-        self.assertIs(True, ui.InfoDialog.run.called)
-
-    def test_show_warning(self):
-        ui_factory = ui.GtkUIFactory()
-        MockMethod.bind(self, ui.WarningDialog, 'run', Gtk.ResponseType.CLOSE)
-        ui_factory.show_warning('test')
-        self.assertIs(True, ui.WarningDialog.run.called)
-
-    def test_show_Error(self):
-        ui_factory = ui.GtkUIFactory()
-        MockMethod.bind(self, ui.ErrorDialog, 'run', Gtk.ResponseType.CLOSE)
-        ui_factory.show_error('test')
-        self.assertIs(True, ui.ErrorDialog.run.called)
-
-    def test_show_user_warning(self):
-        ui_factory = ui.GtkUIFactory()
-        MockMethod.bind(self, ui.WarningDialog, 'run', Gtk.ResponseType.CLOSE)
-        ui_factory.show_user_warning(
-            'recommend_upgrade', current_format_name='1.0', basedir='./test')
-        self.assertIs(True, ui.WarningDialog.run.called)
-
-    def test_show_user_warning_supressed(self):
-        ui_factory = ui.GtkUIFactory()
-        ui_factory.suppressed_warnings.add('recommend_upgrade')
-        MockMethod.bind(self, ui.WarningDialog, 'run', Gtk.ResponseType.CLOSE)
-        ui_factory.show_user_warning(
-            'recommend_upgrade', current_format_name='1.0', basedir='./test')
-        self.assertIs(False, ui.WarningDialog.run.called)
-
-    def test_get_password(self):
-        ui_factory = ui.GtkUIFactory()
-        MockMethod.bind(self, ui.PasswordDialog, 'run', Gtk.ResponseType.OK)
-        mock_property = MockProperty.bind(
-            self, ui.PasswordDialog, 'passwd', 'secret')
-        password = ui_factory.get_password('test')
-        self.assertIs(True, ui.PasswordDialog.run.called)
-        self.assertIs(True, mock_property.called)
-        self.assertEqual('secret', password)
-
-    def test_progress_all_finished_with_widget(self):
-        ui_factory = ui.GtkUIFactory()
-        progress_widget = ui.ProgressPanel()
-        MockMethod.bind(self, progress_widget, 'finished')
-        ui_factory.set_progress_bar_widget(progress_widget)
-        self.assertIs(None, ui_factory._progress_all_finished())
-        self.assertIs(True, progress_widget.finished.called)
-
-    def test_progress_all_finished_without_widget(self):
-        ui_factory = ui.GtkUIFactory()
-        self.assertIs(None, ui_factory._progress_all_finished())
-
-    def test_progress_updated_with_widget(self):
-        ui_factory = ui.GtkUIFactory()
-        progress_widget = ui.ProgressPanel()
-        MockMethod.bind(self, progress_widget, 'update')
-        ui_factory.set_progress_bar_widget(progress_widget)
-        task = ProgressTask()
-        task.msg = 'test'
-        task.current_cnt = 1
-        task.total_cnt = 2
-        self.assertIs(None, ui_factory._progress_updated(task))
-        self.assertIs(True, progress_widget.update.called)
-        self.assertEqual(
-            ('test', 1, 2), progress_widget.update.args)
-
-    def test_progress_updated_without_widget(self):
-        ui_factory = ui.GtkUIFactory()
-        MockMethod.bind(self, ui.ProgressBarWindow, 'update')
-        task = ProgressTask()
-        task.msg = 'test'
-        task.current_cnt = 1
-        task.total_cnt = 2
-        self.assertIs(None, ui_factory._progress_updated(task))
-        self.assertIsInstance(
-            ui_factory._progress_bar_widget, ui.ProgressBarWindow)
-        self.assertIs(True, ui_factory._progress_bar_widget.update.called)
-        self.assertEqual(
-            ('test', 1, 2), ui_factory._progress_bar_widget.update.args)
-
-    def test_report_transport_activity_with_widget(self):
-        ui_factory = ui.GtkUIFactory()
-        progress_widget = ui.ProgressPanel()
-        MockMethod.bind(self, progress_widget, 'tick')
-        ui_factory.set_progress_bar_widget(progress_widget)
-        self.assertIs(
-            None, ui_factory.report_transport_activity(None, None, None))
-        self.assertIs(True, progress_widget.tick.called)
-
-    def test_report_transport_activity_without_widget(self):
-        ui_factory = ui.GtkUIFactory()
-        MockMethod.bind(self, ui.ProgressBarWindow, 'tick')
-        self.assertIs(
-            None, ui_factory.report_transport_activity(None, None, None))
-        self.assertIsInstance(
-            ui_factory._progress_bar_widget, ui.ProgressBarWindow)
-        self.assertIs(True, ui.ProgressBarWindow.tick.called)

=== modified file 'ui.py'
--- ui.py	2012-02-27 21:07:38 +0000
+++ ui.py	2011-09-08 03:11:06 +0000
@@ -24,45 +24,18 @@
 from bzrlib.ui import UIFactory
 
 
-def main_iteration(function):
-    def with_main_iteration(self, *args, **kwargs):
-        result = function(self, *args, **kwargs)
-        while Gtk.events_pending():
-            Gtk.main_iteration_do(False)
-        return result
-    return with_main_iteration
-
-
-class PromptDialog(Gtk.MessageDialog):
+class PromptDialog(Gtk.Dialog):
     """Prompt the user for a yes/no answer."""
 
-    def __init__(self, prompt, parent=None):
-        super(PromptDialog, self).__init__(
-            parent, Gtk.DialogFlags.DESTROY_WITH_PARENT,
-            Gtk.MessageType.QUESTION, Gtk.ButtonsType.YES_NO, prompt)
-
-
-class InfoDialog(Gtk.MessageDialog):
-    """Show the user an informational message."""
-
-    MESSAGE_TYPE = Gtk.MessageType.INFO
-
-    def __init__(self, prompt, parent=None):
-        super(InfoDialog, self).__init__(
-            parent, Gtk.DialogFlags.DESTROY_WITH_PARENT,
-            self.MESSAGE_TYPE, Gtk.ButtonsType.CLOSE, prompt)
-
-
-class WarningDialog(InfoDialog):
-    """Show the user a warning message."""
-
-    MESSAGE_TYPE = Gtk.MessageType.WARNING
-
-
-class ErrorDialog(InfoDialog):
-    """Show the user a warning message."""
-
-    MESSAGE_TYPE = Gtk.MessageType.ERROR
+    def __init__(self, prompt):
+        super(PromptDialog, self).__init__()
+
+        label = Gtk.Label(label=prompt)
+        self.get_content_area().pack_start(label, True, True, 10)
+        self.get_content_area().show_all()
+
+        self.add_buttons(Gtk.STOCK_YES, Gtk.ResponseType.YES, Gtk.STOCK_NO,
+                         Gtk.ResponseType.NO)
 
 
 class GtkProgressBar(Gtk.ProgressBar):
@@ -73,12 +46,10 @@
         self.current = None
         self.total = None
 
-    @main_iteration
     def tick(self):
         self.show()
         self.pulse()
 
-    @main_iteration
     def update(self, msg=None, current_cnt=None, total_cnt=None):
         self.show()
         if current_cnt is not None:
@@ -88,43 +59,21 @@
         if msg is not None:
             self.set_text(msg)
         if None not in (self.current, self.total):
-            fraction = float(self.current) / self.total
-            if fraction < 0.0 or fraction > 1.0:
-                raise ValueError
-            self.set_fraction(fraction)
-
-    @main_iteration
-    def finished(self):
-        self.set_fraction(0.0)
-        self.current = None
-        self.total = None
-        self.hide()
-
-    def clear(self):
-        self.finished()
-
-
-class ProgressContainerMixin:
-    """Expose GtkProgressBar methods to a container class."""
-
-    def tick(self, *args, **kwargs):
-        self.show_all()
-        self.pb.tick(*args, **kwargs)
-
-    def update(self, *args, **kwargs):
-        self.show_all()
-        self.pb.update(*args, **kwargs)
-
-    def finished(self):
-        self.hide()
-        self.pb.finished()
-
-    def clear(self):
-        self.hide()
-        self.pb.clear()
-
-
-class ProgressBarWindow(ProgressContainerMixin, Gtk.Window):
+            self.fraction = float(self.current) / self.total
+            if self.fraction < 0.0 or self.fraction > 1.0:
+                raise AssertionError
+            self.set_fraction(self.fraction)
+        while Gtk.events_pending():
+            Gtk.main_iteration()
+
+    def finished(self):
+        self.hide()
+
+    def clear(self):
+        self.hide()
+
+
+class ProgressBarWindow(Gtk.Window):
 
     def __init__(self):
         super(ProgressBarWindow, self).__init__(type=Gtk.WindowType.TOPLEVEL)
@@ -136,20 +85,54 @@
         self.resize(250, 15)
         self.set_resizable(False)
 
-
-class ProgressPanel(ProgressContainerMixin, Gtk.Box):
+    def tick(self, *args, **kwargs):
+        self.show_all()
+        self.pb.tick(*args, **kwargs)
+
+    def update(self, *args, **kwargs):
+        self.show_all()
+        self.pb.update(*args, **kwargs)
+
+    def finished(self):
+        self.pb.finished()
+        self.hide()
+        self.destroy()
+
+    def clear(self):
+        self.pb.clear()
+        self.hide()
+
+
+class ProgressPanel(Gtk.HBox):
 
     def __init__(self):
-        super(ProgressPanel, self).__init__(Gtk.Orientation.HORIZONTAL, 5)
+        super(ProgressPanel, self).__init__()
         image_loading = Gtk.Image.new_from_stock(Gtk.STOCK_REFRESH,
                                                  Gtk.IconSize.BUTTON)
         image_loading.show()
 
         self.pb = GtkProgressBar()
+        self.set_spacing(5)
         self.set_border_width(5)
         self.pack_start(image_loading, False, False, 0)
         self.pack_start(self.pb, True, True, 0)
 
+    def tick(self, *args, **kwargs):
+        self.show_all()
+        self.pb.tick(*args, **kwargs)
+
+    def update(self, *args, **kwargs):
+        self.show_all()
+        self.pb.update(*args, **kwargs)
+
+    def finished(self):
+        self.pb.finished()
+        self.hide()
+
+    def clear(self):
+        self.pb.clear()
+        self.hide()
+
 
 class PasswordDialog(Gtk.Dialog):
     """ Prompt the user for a password. """
@@ -193,30 +176,6 @@
         dialog.destroy()
         return (response == Gtk.ResponseType.YES)
 
-    def show_message(self, msg):
-        """See UIFactory.show_message."""
-        dialog = InfoDialog(msg)
-        dialog.run()
-        dialog.destroy()
-
-    def show_warning(self, msg):
-        """See UIFactory.show_warning."""
-        dialog = WarningDialog(msg)
-        dialog.run()
-        dialog.destroy()
-
-    def show_error(self, msg):
-        """See UIFactory.show_error."""
-        dialog = ErrorDialog(msg)
-        dialog.run()
-        dialog.destroy()
-
-    def show_user_warning(self, warning_id, **message_args):
-        """See UIFactory.show_user_warning."""
-        if warning_id not in self.suppressed_warnings:
-            message = self.format_user_warning(warning_id, message_args)
-            self.show_warning(message)
-
     def get_password(self, prompt='', **kwargs):
         """Prompt the user for a password.
 
@@ -224,7 +183,7 @@
         :param kwargs: Arguments which will be expanded into the prompt.
                        This lets front ends display different things if
                        they so choose.
-        :return: The password string, return None if the user
+        :return: The password string, return None if the user 
                  canceled the request.
         """
         dialog = PasswordDialog(prompt % kwargs)
@@ -237,24 +196,17 @@
             return None
 
     def _progress_all_finished(self):
-        """See UIFactory._progress_all_finished."""
+        """See UIFactory._progress_all_finished"""
         pbw = self._progress_bar_widget
         if pbw:
             pbw.finished()
 
-    def _ensure_progress_widget(self):
+    def _progress_updated(self, task):
+        """See UIFactory._progress_updated"""
         if self._progress_bar_widget is None:
-            # Default to a window since nobody gave us a better means to report
+            # Default to a window since nobody gave us a better mean to report
             # progress.
             self.set_progress_bar_widget(ProgressBarWindow())
-
-    def _progress_updated(self, task):
-        """See UIFactory._progress_updated."""
-        self._ensure_progress_widget()
         self._progress_bar_widget.update(task.msg,
                                          task.current_cnt, task.total_cnt)
 
-    def report_transport_activity(self, transport, byte_count, direction):
-        """See UIFactory.report_transport_activity."""
-        self._ensure_progress_widget()
-        self._progress_bar_widget.tick()

=== modified file 'viz/branchwin.py'
--- viz/branchwin.py	2012-03-01 21:29:00 +0000
+++ viz/branchwin.py	2011-11-29 10:09:23 +0000
@@ -134,9 +134,9 @@
     def construct_paned(self):
         """Construct the main HPaned/VPaned contents."""
         if self.config.get_user_option('viz-vertical') == 'True':
-            self.paned = Gtk.Paned.new(Gtk.Orientation.HORIZONTAL)
+            self.paned = Gtk.HPaned()
         else:
-            self.paned = Gtk.Paned.new(Gtk.Orientation.VERTICAL)
+            self.paned = Gtk.VPaned()
 
         self.paned.pack1(self.construct_top(), resize=False, shrink=True)
         self.paned.pack2(self.construct_bottom(), resize=True, shrink=False)
@@ -371,9 +371,9 @@
     def construct_bottom(self):
         """Construct the bottom half of the window."""
         if self.config.get_user_option('viz-wide-diffs') == 'True':
-            self.diff_paned = Gtk.Paned.new(Gtk.Orientation.VERTICAL)
+            self.diff_paned = Gtk.VPaned()
         else:
-            self.diff_paned = Gtk.Paned.new(Gtk.Orientation.HORIZONTAL)
+            self.diff_paned = Gtk.HPaned()
         (width, height) = self.get_size()
         self.diff_paned.set_size_request(20, 20) # shrinkable
 
@@ -478,10 +478,7 @@
         else:
             parent_id = parents[0]
 
-        if revision is not None:
-            self.show_diff(revision.revision_id, parent_id)
-        else:
-            self.show_diff(NULL_REVISION)
+        self.show_diff(revision.revision_id, parent_id)
         self.treeview.grab_focus()
 
     def _back_clicked_cb(self, *args):
@@ -657,7 +654,7 @@
             return width, height
         return None
 
-    def show_diff(self, revid, parentid=NULL_REVISION):
+    def show_diff(self, revid=None, parentid=NULL_REVISION):
         """Open a new window to show a diff between the given revisions."""
         from bzrlib.plugins.gtk.diff import DiffWindow
         window = DiffWindow(parent=self)

